<?php
//　初期化
$downloadkey = null;

// load ini.php
require dirname(__FILE__).'/libs/ini.php' ;

if ($_GET&&isset($_GET['filecode'])) {
	// First
	define('FILECODE', $_GET['filecode']);
	define('DOWNLOADKEY', null);
} else if ($_POST&&(isset($_POST['download'])||isset($_POST['delete']))) {
	// Second
	define('FILECODE', $_POST['filecode']);
	define('DOWNLOADKEY', $_POST['downloadkey']);
}

if (!preg_match('/^[a-fA-F0-9]{40}$/',FILECODE)) {
	header('HTTP', true, 403);
	die();
}

// system_config.phpから認証キー（パスワード）取得
if ($downloadkey==null||$downloadkey=='') {
	header('HTTP', true, 403);
	die();
}

// ファイルリストを確認
$filelist = false ;
if (file_exists(MAILFORMPHP_FILELIST)) {
	// ファイルリストを取得
	$filelist = file(MAILFORMPHP_FILELIST);
}
if (!$filelist) {
	header('HTTP', true, 403);
	die();
}

// ファイルリスト内から目的のファイルがあるか調べる
$filename = null;
$savename = null;
$fileline = null; // 行数
foreach($filelist as $line => $upload) {
	list($original_filename,$uploaded_filename,$timestamp) = explode("\t",trim($upload));
	list($filecode,) = explode(".",$uploaded_filename);
	if ($filecode==FILECODE) {
		$filename = $uploaded_filename;
		$savename = $original_filename;
		$fileline = $line;
		break;
	}
}

// 一致するファイルが無ければエラー画面を表示する
if ($filename==null||$savename==null) {
	header('HTTP', true, 404);
	die();
}

// 認証してなければ先にフォーム表示
if (DOWNLOADKEY==null||$downloadkey!=DOWNLOADKEY) {
	$html[] = renderHeader('認証して下さい');
	$html[] = '<script type="text/javascript">';
	$html[] = 'jQuery(function($){ $("input[name=delete]").click(function(){ return confirm("本当に削除してもよろしいですか？") }) })';
	$html[] = '</script>';
	$html[] = '<p>認証キーを入力して下さい</p>';
	$html[] = '<form action="'.$_SERVER['PHP_SELF'].'" method="post">';
	$html[] = '<div style="color:#999">'.date('Y-m-d H:i', $timestamp).'にアップロードされた「'.$savename.'」のダウンロード</div>' ;
	$html[] = '<input type="hidden" name="filecode" value="'.FILECODE.'" />';
	$html[] = '<input type="text" name="downloadkey"/><input type="submit" name="download" value="ダウンロード"/>';
	$html[] = '<input type="submit" name="delete" value="ファイルを削除"/>';
	$html[] = '</form>';
	if(isset($_POST['filecode'])){
		$html[] = '<p style="color:red;">認証キーが正しくありません</p>';
	}
	$html[] = renderFooter();
	die( implode("\n",$html) );
}

$sendfile = MAILFORMPHP_BASE_DIR.MAILFORMPHP_FILE_DIR."/".$filename ;
if (!file_exists($sendfile)) {
	header('HTTP', true, 404);
	die();
}

// ダウンロード開始
if (isset($_POST['download'])){
	require_once 'HTTP/Download.php';
	$download = new HTTP_Download(array(
		"file" => $sendfile
	));
	$download->setContentDisposition(HTTP_DOWNLOAD_ATTACHMENT, $savename);
	$download->send();
	die();
}

// ファイルを削除
else if (isset($_POST['delete'])){
	// ファイルを削除
	unlink($sendfile);
	// 指定行数を削除
	unset($filelist[$fileline]);
	// 結合して再書き込み
	makefile(MAILFORMPHP_FILELIST,implode("\n",$filelist));
	$html[] = renderHeader('削除しました。');
	$html[] = '「'.$savename.'」を削除しました';
	$html[] = renderFooter();
	die( implode("\n",$html) );
}

else {
	die('?');
}