<?php

// 管理画面
require dirname(__FILE__).'/libs/ini.php';
$counter_cgi = MAILFORMPHP_LIBS_DIR.DIRECTORY_SEPARATOR.'counter.cgi' ;
$counter = trim(file_get_contents($counter_cgi));
$counter_modified = filemtime($counter_cgi);

// このファイルへのパス
$action = $_SERVER['PHP_SELF'];

// 認証
$authed_username = myAuth();

// パスワード変更
if (isset($_POST['new_password'])) {
	$alert = null ;
	$js = '$pw=window.parent.$("#passwd");$pw.find("[name=\"new_password\"]").val("");$pw.dialog("close");';
	if( !preg_match('/^([[:alnum:][:punct:]]{6,})$/',$_POST['new_password']) ) {
		$alert = 'パスワードは半角6文字以上で入力してください';
		$js = null;
	}

	if(!$alert) {
		$result = makeAccount($authed_username, $_POST['new_password']);
		if ($result) {
			$alert = 'パスワードを '.html_entity_decode($_POST['new_password']).' に変更しました。';
		} else {
			$alert = 'パスワードの変更に失敗しました。';
		}
	}

	renderHeader($alert);
	echo '<script type="text/javascript">';
	echo 'alert("'.$alert.'");';
	echo $js;
	echo '</script>';
	renderFooter();
	exit(0);
}

if (isset($_SERVER['HTTP_X_REQUESTED_WITH']) && $_SERVER['HTTP_X_REQUESTED_WITH'] == 'XMLHttpRequest') {
	$check_param = mailform::get_check_param();
	if (!preg_match('/^[a-zA-Z0-9\-\.]+$/',$_POST['host'])){
		$error[] = '・ホスト名を正しく入力して下さい';
	}

	if (!preg_match('/^\d+$/',$_POST['port'])){
		$error[] = '・ポート番号を数値で入力して下さい';
	}
	if(	!preg_match('/^[\x01-\x7F]+$/',$_POST['username'])
		||
		!preg_match($check_param['mail']['pattern'],$_POST['username'])
		){
		$error[] = '・ユーザー名の'.$check_param['mail']['message'];
	}
	if(	!preg_match('/^[\x01-\x7F]+$/',$_POST['password']) ){
		$error[] = '・パスワードの'.$check_param['mail']['message'];
	}
	if ($error) {
		die( implode("\n",$error) );
	}

	$result = mailform::check_smtpauth($_POST['host'],$_POST['port'],$_POST['username'],$_POST['password']);
	die($result);
}

$config_dir = MAILFORMPHP_LIBS_DIR.'/' ;
$form_config_php = 'form_config.php';
$system_config_php = 'system_config.php';

$form_config_path = $config_dir . $form_config_php ;
$system_config_path = $config_dir . $system_config_php ;

$request = $_POST ? $_POST : $_GET;
$form = post_filter($request);

define( 'isFormConfig', !$form||$form['mode']!='system_config'?true:false );
define( 'isSystemConfig', isFormConfig?false:true );

// 変数生成用
$replace_before = array("\r","\n");
$replace_after = array("","\\n");
$out_replace_before = array("\'");
$out_replace_after = array("'");

/*
 * デフォルトのキー
 */
$default_key = array(
	'title',
	'required',
	//'formtype',
	'setname', // use formtype
	'type', // use formtype
	'recipients',
	'size',
	'cols',
	'rows',
	'select_values',
	'comment_before',
	'comment_after',
	'output_options',
	'convert_options',
	'check_options'
);

// 基本URL生成
$protocol = $_SERVER['HTTPS']=='on' ? 'https' : 'http' ;
$request_uri = explode( '/', $_SERVER['REQUEST_URI'] );
$request_uri[ count($request_uri)-1 ] = '';
$example_url = $protocol . '://' . $_SERVER['HTTP_HOST'] . implode('/', $request_uri);

/*
 * デフォルトの設定
 */
$default_ini = array(
	'base_url' => '',
	'template_type' => 1,
	'template_mojicode_p' => 1,
	'template_mojicode_k' => 1,
	'template_mojicode_s' => 1,
	'downloadkey' => null,
	'thanks_mail_use' => 1,
	'thanks_mail_from_name' => null,
	'thanks_mail_from_mail' => null,
	'thanks_mail_from_smtp_auth' => 2,
	'thanks_mail_from_smtp_host' => null,
	'thanks_mail_from_smtp_port' => null,
	'thanks_mail_from_smtp_username' => null,
	'thanks_mail_from_smtp_password' => null,
	'thanks_mail_subject' => null,
	'alert_mail_subject' => null,
	'alert_mail_to1' => null,
	'alert_mail_to2' => null,
	'alert_mail_to2_subject' => null,
	'alert_mail_to2_body' => null,
	'thanks_mail_template_p' => 'お問い合わせありがとうございました。\nご入力いただいた内容は以下になります。\n{mailform}\n\n以上です。',
	'thanks_mail_template_k' => 'お問い合わせありがとうございました。\nご入力いただいた内容は以下になります。\n{mailform}\n\n以上です。',
	'thanks_mail_template_s' => 'お問い合わせありがとうございました。\nご入力いただいた内容は以下になります。\n{mailform}\n\n以上です。',
	'alert_mail_template_p' => 'フォームより問い合わせがありました。\n入力された内容は以下になります。\n{mailform}\n\n以上です。',
	'alert_mail_template_k' => 'フォームより問い合わせがありました。\n入力された内容は以下になります。\n{mailform}\n\n以上です。',
	'alert_mail_template_s' => 'フォームより問い合わせがありました。\n入力された内容は以下になります。\n{mailform}\n\n以上です。',
	'size_name' => 8,
	'size_namehira' => 10,
	'size_mail' => 30,
	'size_tel1' => 15,
	'size_tel3' => 6,
	'size_zip' => 9,
	'size_zip1' => 4,
	'size_zip2' => 5,
	'size_city' => 20,
	'size_addr' => 30,
	'size_bldg' => 30,
	'size_url1' => 30,
	'size_input' => 20,
	'cols_textarea' => 30,
	'rows_textarea' => 10,
);

$error = array();
if($form&&array_key_exists('action',$form)&&$form['action']=='submit'){
	$insert = array();

	// フォーム設定の保存
	if(isFormConfig){
		// セットタイプの中にメールアドレスの項目があるかチェック
		$mail_type_exists = false ;
		// 確認メールの送信先として使用するにチェックがあるか
		$recipients_check = false ;
		$save_config_php = $form_config_php;
		$save_config_path = $form_config_path;

		// 確認メールが利用しないの場合に確認をスルーする為に設定値読み込み
		if(file_exists($system_config_path)){
			$__thanks_mail_use = $default_ini['thanks_mail_use']; // デフォルトを設定
			$system_config_string = file_get_contents( $system_config_path );
			preg_match('/\$thanks_mail_use = (1|2);/',$system_config_string,$match);
			if($match[1]==1||$match[1]==2){
				$__thanks_mail_use = $match[1]; // 1|2　実際の設定値が入る
			}

			// 利用しない設定の場合
			if ($__thanks_mail_use==2) {
				// 一覧内にメールアドレスの項目がある事にする（＝チェックしない）
				$mail_type_exists = true ;
				// 確認メールの送信先としてチェックがある事にする（＝チェックしない）
				$recipients_check = true ;
			}
		}

		// デフォルト値セットのためシステム設置値をロード
		if( file_exists($system_config_path) ){
			require_once $system_config_path;
		}

		$total_column = count($form['title']);

		for($line=0;$line<$total_column;$line++){
			foreach( $default_key as $name ) {
				$value = trim($form[$name][$line]);
				$value = str_replace($replace_before,$replace_after,$value);
				switch($name){
					case 'title':
						if($value==''){
							$error[$line][$name] = '入力必須項目です';
						}
						break;
					case 'required':
						if($value!='yes'&&$value!='no'){
							$error[$line][$name] = '不正な値です';
						}
						break;
					case 'setname':
					case 'type':
						if($error[$line]['formtype']) break ;

						// $default_keyには$nameが無いので独自に取得
						$value = $form['formtype'][$line];
						if(!$value){
							$error[$line]['formtype'] = '選択必須項目です';
							break;
						}
						list($key,$val) = explode(':',$value);
						if(($key=='setname'||$key=='type')&&$key==$name){
							$value = $val;
						} else {
							$value = null;
						}

						if(!$mail_type_exists&&($val=='mail1'||$val=='mail2')){
							// 設定内にメールアドレスがあればOKとする
							$mail_type_exists = true ;
						}
						break;

					case 'recipients':
						if($recipients_check){
							$value='no';
						}
						if($value!='yes'&&$value!='no'){
							$error[$line][$name] = '不正な値です';
						} else if($value=='yes'){
							$recipients_check = true ;
							$insert[$line]['required'] = 'yes';
						}
						break;

					case 'select_values':
						// すでに設定された値から確認を行う
						if(
							$insert[$line]['type']!='input_radio'
							&& $insert[$line]['type']!='input_checkbox'
							&& $insert[$line]['type']!='select'
							){
							$value = null ; // 強制的に空に
						}
						// 対象の場合は値を使う
						else {
							$value = htmlspecialchars(strip_tags($value));
						}
						break;
					case 'comment_before':
					case 'comment_after':
						// 特にチェック無し
						break;

					case 'output_options':
					case 'convert_options':
					case 'check_options':
						// 特にチェック無し
						break;

					case 'size':
						if($form['formtype'][$line]!='type:input_text'){
							$value = null ;
						} else {
							if( $value !='' ){
								if (!preg_match('/^\d+$/',$value)) {
									$error[$line][$name] = '整数を入力して下さい';
								}
							} else {
								// 未入力ならデフォルト値をセット
								$value = $size_input ? $size_input : $default_ini['size_input'];
							}
						}
						break;
					case 'cols':
					case 'rows':
						if($form['formtype'][$line]!='type:textarea'){
							$value = null ;
						} else {
							if( $value !='' ){
								if (!preg_match('/^\d+$/',$value)) {
									$error[$line][$name] = '整数を入力して下さい';
								}
							} else {
								// 未入力ならデフォルト値をセット
								if( $name=='cols' ) {
									$value = $cols_textarea ? $cols_textarea : $default_ini['cols_textarea'];
								} else if( $name=='rows' ) {
									$value = $rows_textarea ? $rows_textarea : $default_ini['rows_textarea'];
								}
							}
						}
						break;
				}
				$insert[$line][$name] = $value ;
			}
		}

		if ($__thanks_mail_use) {
			if($mail_type_exists===false){
				$error['save'] = '最低１つは「セット/タイプ」に「メールアドレス」が必要です。';
			}

			if($recipients_check===false){
				$error['save'] = '「確認メールの送信先として使用する」を1箇所設定して下さい。';
			}
		}
	}

	// メール設定の保存
	else if(isSystemConfig){
		$save_config_php = $system_config_php;
		$save_config_path = $system_config_path;

		// チェックパターン取得
		$check_param = mailform::get_check_param();

		// SMTP認証を使う場合の４項目チェックフラグ
		$use_smtpauth = false;

		foreach($default_ini as $name => $value){
			if(isset($form[$name])) {
				// @todo ユーザー値のエラーチェック
				switch($name){
					case 'base_url':
						if (!preg_match($check_param['url']['pattern'],$form[$name])){
							$error[$name] = 'URLの'.$check_param['url']['message'];
						}
						elseif (!preg_match('@/$@',$form[$name])) {
							$error[$name] = 'URLの最後は/で終わって下さい。';
						}
						break;
					case 'template_type':
						if (!preg_match("/^[1234]$/",$form[$name])){
							$error[$name] = '正しく選択されていません。';
						}
						break;
					case 'template_mojicode_p':
					case 'template_mojicode_k':
					case 'template_mojicode_s':
						if (!preg_match("/^[123]$/",$form[$name])){
							$error[$name] = '正しく選択されていません。';
						}
						break;
					case 'thanks_mail_use':
						if (!preg_match("/^[12]$/",$form[$name])){
							$error[$name] = '正しく選択されていません。';
						}
						break;
					case 'thanks_mail_from_mail':
					case 'alert_mail_to1':
						if (!$form[$name]){
							$error[$name] = 'メールアドレスを入力して下さい。';
						}
						elseif(!preg_match($check_param['mail']['pattern'],$form[$name])){
							$error[$name] = 'メールアドレスの'.$check_param['mail']['message'];
						}
						break;
					case 'thanks_mail_from_smtp_auth':
						if ($form[$name]==2) {
							$form['thanks_mail_from_smtp_host'] = '';
							$form['thanks_mail_from_smtp_port'] = '';
							$form['thanks_mail_from_smtp_username'] = '';
							$form['thanks_mail_from_smtp_password'] = '';
						} else {
							$use_smtpauth = true ;
						}
						break;
					case 'thanks_mail_from_smtp_host':
						break;
					case 'thanks_mail_from_smtp_port':
						if ($use_smtpauth) {
							if (!preg_match('/^\d+$/',$form[$name])){
								$error[$name] = 'ポート番号を数値で入力して下さい';
							}
						}
						break;
					case 'thanks_mail_from_smtp_username':
						if ($use_smtpauth) {
							if(	!preg_match('/^[\x01-\x7F]+$/',$form[$name])
								||
								!preg_match($check_param['mail']['pattern'],$form[$name])
							){
								$error[$name] = 'ユーザー名の'.$check_param['mail']['message'];
							}
						}
						break;
					case 'thanks_mail_from_smtp_password':
						if ($use_smtpauth) {
							if(	!preg_match('/^[\x01-\x7F]+$/',$form[$name]) ){
								$error[$name] = 'パスワードの'.$check_param['mail']['message'];
							}
						}
						break;
				}

				// ユーザー値で上書き
				$value = $form[$name] ;
			}

			$insert[$name] = $value ;
		}

	}

	if($save_config_path&&!$error){
		if(!is_writable($save_config_path)){
			$error['save'] = 'ファイルの変更権限がありません。ファイル（'.$save_config_php.'）やフォルダ（'.$config_dir.'）のパーミッションを確認して下さい。';
		} else {
			// 作成するPHPファイルの準備
			$php[] = '<?php';
			$php[] = '/* ';
			$php[] = ' * ' . $save_config_php;
			$php[] = ' * 最終更新日時：' . date('Y.m.d H:i');
			$php[] = ' */';
			if($form['mode']=='form_config'){
				foreach($insert as $line => $values){
					$php[] = '// No.' . ($line+1) . ': ' . $insert_values['title'] ;
					$php[] = '$form_config[] = array(';
					foreach($values as $name => $value){
						$php[] = "\t".addArraysValue($name,$value) ;
					}
					$php[] = ');';
					$php[] = ''; // add \n
				}
			} elseif ($form['mode']=='system_config') {
				foreach($insert as $name => $value){
					$php[] = addDefine($name,$value) ;
				}
			}

			// 作成（新規|上書）
			// $save_result = file_put_contents($save_config_path, implode("\n",$php));
			// PHP4対応
			$save_result = makefile($save_config_path, implode("\n",$php));
		}
	}
}

// フォーム設定の読込
if(isFormConfig){
	if(file_exists($form_config_path)){
		$m = new mailform ;
		$m->getSetting();
		// require_once $form_config_path;
		if($error){
			$m->setting = $insert;
		}
	}
}

// メール設定の読込
else if(isSystemConfig){
	if(file_exists($system_config_path)){
		require_once $system_config_path;

		if(file_exists($form_config_path)){
			$m = new mailform ;
			$m->getSetting();

			if ($thanks_mail_use=='1') {
				$found_mail_setting = false;
				$found_recipients_yes = false;
				foreach( $m->setting as $key => $setting ) {
					if ( $setting['setname'] == 'mail1' || $setting['setname'] == 'mail2' ) {
						if ( !$found_mail_setting ) {
							$found_mail_setting = true;
						}
						if ( !$found_recipients_yes && $setting['recipients'] == 'yes' ) {
							$found_recipients_yes = true;
						}
					}
				}
			}
		}


	}
}

?>
<?php echo renderHeader('メールフォームPHP管理画面'); ?>
<?php if(isFormConfig):?>
<script type="text/javascript">
var separator = {
	output_options: ',',
	convert_options: ',',
	check_options: '|',
	other: ':'
};
jQuery(function($){

	var $modal = $('#modal').hide(),
		modalInputReset = function(){
			$modal.find('input:checked').prop('checked',false);
			$modal.find('input:text').val('');
			$modal.find('select').val('');
		};

	// 1項目内のそれぞれに割当てるアクション
	var columnSetup = function(index,li){

		// <button>をボタン化
		$('button',li).button().parents('td,th').css({'text-align':'center'});

		$('[name^="required"]',li).parent().find('input:checkbox').change(function(){
			var $required = $(this).parent().find('input:hidden');
			$required.val( $(this).prop('checked') ? 'yes' : 'no' );
		})

		$('[name^="recipients"]',li).parent().find('input:checkbox').change(function(){
			var $recipients = $(this).closest('div').find('input:hidden');
			$recipients.val( $(this).prop('checked') ? 'yes' : 'no' );
		})


		// 個数チェック
		$('.options',li)
			.each(function(i,e){
				$(e).attr('disabled',true);
				optionsUpdate($(e));
			})
			.click(function(){
				var self = $(this),
					vals = getOptions(self),
					input = self.parent().find('input:hidden'),
					name = input.attr('name').replace('[]',''),
					block = '#'+name+'_block';

				if(vals.length>0){
					var labels = new Array;
						labels[ labels.length ] = '▼以下のオプションが選択されています';

					$.each(vals,function(k,v){
						if (v.match(/^other_extension:/)) {
							// その他拡張子
							var other_extension = v.split(separator.other);
							labels[ labels.length ] = '「その他拡張子（' + other_extension[1] + '）」' ;
						} else if (v.match(/^filesize:/)) {
							// アップロード容量
							var filesize = v.split(separator.other);
							labels[ labels.length ] = '「アップロード可能な容量（'+filesize[1]+filesize[2]+'）」' ;
						} else if (v.match(/^dec:/)) {
							// 整数値の桁整形
							var dec = v.split(separator.other);
							labels[ labels.length ] = '「整数値を'+dec[1]+'桁に整形する」' ;
						} else {
							var label_for = name + '_' + v ,
								label = $(block).find('label[for="'+label_for+'"]');
							if (label.length) {
								labels[ labels.length ] = '「' + label.html() + '」';
							}
						}
					})
					alert( labels.join("\n") );
				}
				return false;
			})

		// セット/タイプ
		$('select[name^="formtype"]',li).change(function(){
			var options = formtype($(li),this.value);
			$.each(options,function(i,self){
				optionsUpdate(self);
			});
			return false;
		})

		// サイズ
		$('input[name^="size"], input[name^="cols"], input[name^="rows"]',li).keyup(function(e){
			var V = keyCalc(e, $(this));
			if (V) $(this).val(V);
		})

		$('.delete',li).click(function(){
			var $li = $(li),
				title = $li.find('[name^="title"]').val();

			title = 'No.'+$.trim($li.find('td:first').html()) + (title=='' ? '' : '「'+title+'」') ;

			if(confirm(title+'を削除してもよろしいですか？')){
				$li.hide(500,function(){
					$li.remove();
					reNumbering();
					trbg();
					enableInput();
					showNotSave();
				})
			}
			return false;
		})

		// セット化
		$('button.modal',li).button({
			text: false,
			icons: {
				primary: "ui-icon-triangle-1-s"
			}
		}).parent().buttonset();

		/*
		* モーダル表示
		*/
		$('.modal',li).click(function(){
			var $self = $(this), modalButtons={},
				tagname = this.tagName.toLowerCase(),
				$parent_td = $self.parents('td'),
				title = $('#tableHeader').find('thead th').eq($parent_td.index()).html();

			if(tagname=='button'){
				var $prev = $self.prev(),
					$hidden = $self.closest('td').find('input:hidden'),
					name = $hidden.attr('name').replace('[]',''),
					values = $hidden.val().split(separator[name]),
					block = '#'+name+'_block';

				if(name=='check_options'){
					$('#check_options_other_extension').prop('checked',false);
					$('#check_options_other_extensions').val('');
					var classname = $self.closest('tr').find('[name^="formtype"]').val().replace(':','-');
					$('#check_options_block>div').hide();
					$('#check_options_block>div').each(function(i,e){
						if($(e).hasClass(classname)){
							$(e).show();
						}
					})
				}

				// input:checkbox
				if($(block).attr('rel')=='checkbox') {
					$(block).find('input:checkbox').prop('checked',false);
				}
				// input:radio
				else if($(block).attr('rel')=='radio') {
					$(block).find('input:radio').prop('checked',false);
				}

				// 保存されている値を反映
				$.each(values,function(k,v){
					if(name=='check_options'){
						if (v.match(/^other_extension:/)) {
							$('#check_options_other_extension').prop('checked',true);
							var other = v.split(separator.other);
							$('#check_options_other_extensions').val(other[1]);
						} else if (v.match(/^filesize:/)) {
							$('#check_options_filesize').prop('checked',true);
							var filesize = v.split(separator.other);
							// ex) size:1
							$('#check_options_filesize_size').val(filesize[1]);
							// ex) byte:KB
							$('#check_options_filesize_byte').val(filesize[2]);
						} else {
							if ($(block)[0]) {
								var $checkbox = $(block).find('[value='+v+']');
								if($checkbox.length>0){
									checkOptionGroup($checkbox,true);
								}
							}
						}
					} else if (name=='output_options') {
						if (v.match(/^dec:/)) {
							$('#output_options_dec').prop('checked',true);
							var dec = v.split(separator.other);
							$('#output_options_dec_value').val(dec[1]);
						} else {
							$(block).find('[value='+v+']').prop('checked',true);
						}
					} else {
						$(block).find('[value='+v+']').prop('checked',true);
					}
				})

				modalButtons = {
					"上記内容で適用": function(){
						var checked = new Array;
						// rel=ignoreを持つ物は無視する
						$(this).find('>div:visible input:checked[rel!="ignore"]').each(function(i,e){
							if($(e).val()!='') checked[ checked.length ] = $(e).val();
						});
						if (name=='check_options') {
							// その他拡張子
							if ($('#check_options_other_extension').prop('checked')) {
								var other_extension = $.trim( $('#check_options_other_extensions').val() );
								if(other_extension){
									// 入力された拡張子をother:と繋いで保存
									checked[ checked.length ] = 'other_extension'+separator.other+other_extension ;
								}
							}

							if ($('#check_options_filesize').prop('checked')) {
								var file_size = $('#check_options_filesize_size').val(),
									file_byte = $('#check_options_filesize_byte').val();

								if ( file_size && file_byte ) {
									checked[ checked.length ] = 'filesize' + separator.other + file_size + separator.other + file_byte ;
								}
							}
						}

						if (name=='output_options') {
							if ($('#output_options_dec').prop('checked')) {
								checked[ checked.length ] = 'dec' + separator.other + $('#output_options_dec_value').val() ;
							}
						}

						// チェックがあったものを保存
						$hidden.empty().val(checked.join(separator[name]));
						optionsUpdate($prev);
						modalInputReset();
						$modal.dialog('close');
						showNotSave();
					},
					"キャンセル": function(){
						optionsUpdate($prev);
						modalInputReset();
						$modal.dialog('close');
					}
				}

			} else {
				var $textarea = $self.parent().find('textarea'),
					$hidden = $self.parent().find('input:hidden'),
					name = $self.parent().find('input:hidden').attr('name').replace('[]',''),
					block = '#'+name+'_block';

				$(block).find('textarea').val( $textarea.val() );

				modalButtons = {
					"上記内容で適用": function(){
						var trim_value = $.trim($(this).find('textarea').val()).replace(/\n+/g,"\n");
						$textarea.val( trim_value );
						$hidden.val( trim_value );
						modalInputReset();
						$modal.dialog('close');
						showNotSave();
					},
					"キャンセル": function(){
						modalInputReset();
						$modal.dialog('close');
					}
				}
			}

			$modal.find('.blocks').hide();
			$(block).show();

			$modal.dialog({
				resizable: false,
				modal: true,
				width: 550,
				height: 350,
				title: title,
				close: modalInputReset,
				buttons: modalButtons
			})
			return false;
		})

	}

	$('#sortable li').each(function(i,e){
		columnSetup(i,e);
	})

	// モーダル内のチェックを全て外す
	$('.clear')
		.click(function(){
			modalInputReset();
		})
		.button({
			icons: {
				primary: "ui-icon-close"
			}
		})

	$("#sortable").sortable({
		revert: true,
		handle: 'td:first',
		placeholder: 'ui-state-highlight',
		forceHelperSize: true,
		forcePlaceholderSize: true,
		containment: 'parent',
		stop: function(){
			$("#sortable").find('.myPlaceHolder').remove();
			reNumbering();
			trbg();
			enableInput();
		}
	}).disableSelection();

	// テーブルのセルサイズ調整
	var cels = $('#tableHeader th').length ;
	var w = [
		30, 150, 35, 250, 160, 200, 90, 90, 110
	];
	for(var i=0; i<cels; i++){
		$('#wrapper table').each(function(tbl_index,tbl){
			var cel = $(tbl).find('th,td');
			cel.eq(i).addClass( cel.get(0).tagName.toLowerCase()+i ).width(w[i]);
		})
	}

	// check_optionsの子
	$('#check_options_block li').find('input:checkbox').each(function(){
		$(this).change(function(){
			checkOptionGroup( $(this), $(this).prop('checked')?true:false );
		})
	})

	// check_optionsの親
	$('#check_options_block>div>div>input:checkbox').each(function(){
			$(this).change(function(){
				var $checkbox = $(this).closest('div').find('>ul input:checkbox');
				if($checkbox.length>0){
					var checked = $(this).prop('checked') ? true : false ;
					$checkbox.prop('checked',checked);
				}
			})
	})

	$('#add').click(function(){
		var $li = $('<li/>').hide().wrapInner( $('#datatable-sample').clone(true) );
		$li.find('table').attr('id','');
		$('#sortable').append($li);
		var sortable_length = reNumbering();
		columnSetup(sortable_length-1,$li.get(0));
		formtype($li,null);
		trbg();
		enableInput();
		$li.fadeIn();
		showNotSave();
		return false;
	})

	trbg();
	enableInput();
})

var formtype = function(li,setname,type){
	var value = setname != 'setname:' ? setname : type ,
		$tr = li.find('tr'),
		$target = $tr.find('select[name^="formtype"]'),
		div = $target.val(value).next(),
		modalDisabled = null,
		options = new Array ;
	div.find('>div').hide();


	var select_values = {};
	if(
		value=='type:input_radio'
		|| value=='type:input_checkbox'
		|| value=='type:select'
	){
		select_values.opacity = 1;
		select_values.css = {
			'background': '#fff'
		};
		select_values.display = 'show';
		select_values.disabled = false ;
	} else {
		select_values.opacity = .5;
		select_values.css = {
			'background': '#ccc'
		};
		select_values.display = 'hide';
		select_values.disabled = true ;
	}

	$tr.find('input[name^="select_values"]').next()
		.change(function(){
			$(this).prev().val($(this).val())
		})
		.css(select_values.css).attr('disabled',select_values.disabled)
		.removeClass().addClass(select_values.addclass)
		.closest('td').find('a.textlink')[select_values.display]()


	$.each(['output_options','convert_options','check_options'],function(i,options_name){
		modalDisabled = true ;
		if(value){
			var classname = value.replace(':','-');
			div.find('.'+classname).show();
			$('#'+options_name+'_block>div').each(function(i,e){
				if($(e).hasClass(classname)){
					modalDisabled = false ;
				}
			})
		}

		if(modalDisabled){
			$tr.find('[name^="'+options_name+'"]').val('');
		}

		// input > (prev) > .modal > (prev) > .options
		options[ options.length ] = $tr.find('[name^="'+options_name+'"]').prev().attr('disabled',modalDisabled).button('refresh').prev()
	})
	return options ;
}

var reNumbering = function(){
	$('#sortable li table tbody tr').each(function(i,e){
		var td = $(this).find('td:first');
		td.html(i+1);
	})
	// 最後のNoを返す
	return $('#sortable li').length ;
}

var trbg = function() {
	$('#sortable tbody tr:odd').removeClass('even').addClass('odd');
	$('#sortable tbody tr:even').removeClass('odd').addClass('even');
}

var getOptions = function(self){
	var input = self.parent().find('input:hidden'),
		value = $.trim(input.val());
	if(value){
		return input.val().split( separator[input.attr('name').replace('[]','')] );
	} else {
		return new Array();
	}

}

var optionsUpdate = function(self){
	var vals = getOptions(self),
		isDisabled = false ;

	if(vals.length==0){
		self.find('em').html( 0 );
		isDisabled = true ;
	} else {
		self.find('em').html( vals.length );
		isDisabled = false ;
	}
	self.button({'disabled': isDisabled}).button('refresh');
}

var enableInput = function(){
	// enable text select on inputs
	$("#sortable").find("input, select, textarea")
		.bind('mousedown.ui-disableSelection selectstart.ui-disableSelection', function(e) {
			e.stopImmediatePropagation();
		});
}

var checkOptionGroup = function($checkbox,checked){
	$checkbox.prop('checked',checked);
	var $ul = $checkbox.closest('ul'),
		checkbox_count = $ul.find('input:checkbox').length,
		checked_count = $ul.find('input:checked').length,
		parentResult = checkbox_count>0 ? ( checked_count<checkbox_count ? false : true ) : false ;
	$ul.closest('div').find('>input').prop('checked',parentResult);
	return parentResult;
}

</script>
<?php endif;?>

<?php if(isSystemConfig):?>
<script type="text/javascript">
var default_ini={}, user_ini={}, ini={};
jQuery(function($){
	$('.button').button();
	$('.radioset').buttonset();
	$('.radioset label').click(function(){showNotSave()});

<?php
	foreach($default_ini as $key => $value){
		$value = $value!='' ? "'".$value."'" : 'null';
		echo "\tdefault_ini.{$key} = {$value};\n";

		// 設定時にエラーがある場合
		if($error){
			if($form[$key]!=''){
				$value = "'".str_replace($replace_before,$replace_after,$form[$key])."'";
			} else {
				$value = 'null';
			}
			echo "\tuser_ini.{$key} = {$value};\n";
		}
		elseif(isset($$key)){
			if($$key!=''){
				$value = "'".str_replace($replace_before,$replace_after,$$key)."'";
			} else {
				$value = "'".$default_ini[$key]."'";
			}
			echo "\tuser_ini.{$key} = {$value};\n";
		}
	}
?>

	ini = $.extend(default_ini, user_ini);

	$.each(ini, function(key,value){
		var $target = $('[name^="'+key+'"]');
		if($target.length>0){
			switch($target[0].type){
			case 'radio':
				$target = $('[name^="'+key+'"][value="'+value+'"]');
				$target.prop('checked',true).button('refresh');
				break;

			case 'text':
			case 'password':
			case 'textarea':
				if(value) {
					$target.val(value);
				}
				break;
			}
		}
	})

})
</script>
<?php endif;?>
<script type="text/javascript">

var execBeforeUnload = false;
function cancelBeforeUnload() {
	execBeforeUnload = false;
	setTimeout(function() {
		execBeforeUnload = true;
	}, 100);
}

function stealthBlank(url){
	w=window.open() ;
	w.document.open();
	w.document.write('<html><head><meta http-equiv="Refresh" content="0;URL='+url+'"></head></html>');
	w.document.close();
}

function keyCalc(event, $self){
	var K = event.keyCode,
		S = event.shiftKey ? true : false,
		_V = $self.val(),
		V = parseInt(_V);
	if (K==38) { // ↑
		V=V+(S?10:1);
	}
	if (K==40) { // ↓
		V=V-(S?10:1);
	}
	if (!$self.val().match(/^\d+$/)) V=1;
	if (V<1) V=1;
	if (V>100) V=100;
	if (_V!=V) return V;
	return null;
}

jQuery(function($){
	var isFormConfig = <?php echo (isFormConfig?'true':'false');?>,
		isSystemConfig = <?php echo (isSystemConfig?'true':'false');?>;

	$(".blank").click(function(){
		stealthBlank(this.href);
		return false ;
	});

	$(window).bind('beforeunload', function(e) {
		if (execBeforeUnload) {
			return 'ページを移動する場合、変更は破棄されます。';
		}
	});

	$('a').click(function(e) {
		if (e.target.href && e.target.href.indexOf("javascript") === 0) {
			cancelBeforeUnload();
		}
	});

	// btn:フォーム設定
	$('#cPanel .form_config')
		.button({
			disabled: isFormConfig,
			icons: { primary: "ui-icon-document" }
		})

	// btn:システム設定
	$('#cPanel .system_config')
		.button({
			disabled: isSystemConfig,
			icons: { primary: "ui-icon-wrench" }
		})

	// btn:保存
	$('#cPanel .save_action')
		.button({
			icons: { primary: "ui-icon-pencil" }
		})
		.click(function(){
			cancelBeforeUnload();
			var mode;
			if(isFormConfig){
				mode = 'form_config';
			}

			else if(isSystemConfig){
				mode = 'system_config';
			}

			$('<input>').attr({
				'type': 'hidden',
				'name': 'mode'
			}).val(mode).appendTo('#'+mode);
			$('<input>').attr({
				'type': 'hidden',
				'name': 'action'
			}).val('submit').appendTo('#'+mode);
			$('#'+mode).submit();
		})

	$('#cPanel .passwd_link')
		.button({
			icons: { primary: "ui-icon-arrowrefresh-1-w" }
		})
		.click(function(){
			$('#passwd').dialog({
				resizable: false,
				modal: true,
				width: 200,
				height: 130,
				title: 'パスワード変更',
				buttons: {
					'キャンセル':function(){
						$(this).find('input:text').val('');
						$(this).dialog('close');
					},
					'変更する':function(){
						var _execBeforeUnload = execBeforeUnload;
						execBeforeUnload = false ;
						$(this).find('form').submit();
						execBeforeUnload = _execBeforeUnload ;
						return false;
					}
				}
			});
			return false;
		})

	$('#cPanel .form_link')
		.button({
			icons: { primary: "ui-icon-newwin" }
		})

	$('#cPanel .logout')
		.button({
			icons: { primary: "ui-icon-unlocked" }
		})
		.click(function(){
			var _execBeforeUnload = execBeforeUnload;
			execBeforeUnload = false ;
			if (!confirm('ログアウトしますか？')) {
				execBeforeUnload = _execBeforeUnload ;
				return false;
			}
		})

	$('#wrapper').fadeIn();
	$('#save_result').delay(5000).fadeOut();
	
	$('input, textarea, select, button','form').each(function(i,element){
		jQuery.data($(element).get(0), 'set_value', $(element).val());
	})

	showNotSave = function(){
		$('#notSave').css('display','inline-block');
		execBeforeUnload = true;
	};
	var notSaveChecker = function(element){
		var value = jQuery.data($(element).get(0), 'set_value');
		if(value!=$(element).val()){
			showNotSave();
		}
	}
	$('input:not(.nosavecheck), textarea, select', 'form')
		.on('change',function(){
			notSaveChecker(this);
		})
		.on('blur',function(){
			notSaveChecker(this);
		})
})
</script>
<style type="text/css">
	html, body {
		font-family:'ヒラギノ角ゴ Pro W3','Hiragino Kaku Gothic Pro',osaka,'メイリオ',Meiryo,'ＭＳ Ｐゴシック',sans-serif;
		font-size: 13px;
		color: #333;
	}
	div, p{
		margin: 0;
		padding: 0;
	}
	#wrapper table{
		border-collapse: collapse;
		border-spacing: 0;
		width: 100%;
		table-layout: fixed;
	}
	#wrapper th,
	#wrapper td{
		padding: 3px;
		border-width: 1px 1px 1px 1px;
		border-style: solid;
		border-color: #ddd;
		font-size: 8pt;
		font-weight: normal;
		white-space: nowrap;
	}
	#wrapper thead th,
	#wrapper thead td{
		border-width: 1px ;
		border-color: #ccc;
		background: #ddd;
	}
	#wrapper tr.odd,
	table tr.bg{
		background:#f0f0f0;
	}
	#wrapper tr.even{
		background:#fff;
	}
	#wrapper .td0 {
		cursor: move;
		text-align: center;
	}
	#wrapper tr.odd .td0{
		background:#e6e6e6;
	}
	#wrapper tr.even .td0{
		background:#f6f6f6;
	}
	#wrapper tr.odd:hover td,
	#wrapper tr.even:hover td{
		background:#ffc;
		border-width: 1px;
		border-color: #aaa;
	}
	#wrapper tr.odd:hover .td0,
	#wrapper tr.even:hover .td0{
		background:#ff0;
		color: #333;
	}
	#wrapper .td2{
		text-align: center;
	}

	#datatable-sample {
		display: none;
	}

	ul, li{
		margin: 0;
		padding: 0;
		list-style: none;
	}
	li {
		margin-bottom: 2px;
	}

	input,
	textarea,
	select {
		font-size: 8pt;
		padding: 2px;
		border: 1px solid #999;
		background: #fff;
		-moz-border-radius: 3px;
		-webkit-border-radius: 3px;
		-o-border-radius: 3px;
		-ms-border-radius: 3px;
		position: relative;
		outline: 1;
	}

	textarea{
		line-height: 1.2;
		resize: none;
		height: 5em;
	}

	#select_values_block textarea {
		width: 500px;
		height: 220px;
	}

	.input_comment {
		width: 180px;
	}

	button,
	button * {
		font-size: 8pt;
	}

	#modal label{
		display: inline-block;
		padding: 3px;
	}

	#modal input:checked+label {
		color: red;
	}
	.options em {
		padding-right: 3px;
		font-style: normal;
	}

	#sortable .ui-sortable-helper td {
		border-width: 1px !important;
	}

	#tableHeader {
		margin-bottom: 2px;
	}
	.blocks {
		display: none;
	}
	.blocks div {
		clear: both;
/*		margin-bottom: 0.5em;*/
	}

	.blocks ul {
		border: 1px solid #ccc;
		overflow: hidden;
		padding: 5px;
	}

	.blocks li {
		float: left;
		padding-right: 1em;
	}

	p.indent {
		margin-top: 3px;
		font-size: 8pt;
		text-indent: -1em;
		padding-left: 1em;
		white-space: normal;
		line-height: 1.3;
	}

	#cPanel {
		position: fixed;
		top: 0;
		left: 0;
		z-index:900;
		background: #f6f6ff;
		width: 100%;
		height: 32px;
		padding: 2px;
		overflow: hidden;
		border-bottom: 2px solid #ccf;
	}
	body {
		margin-top: 46px;
	}

	#cPanel h1 {
		float: left;
		height: 30px;
		font-size: 10pt;
		margin: 0;
		padding: 0;
		line-height: 30px;
		box-sizing: border-box;
		border: 1px solid #ccc;
		border-radius: 3px;
		padding: 0 10px;
		background: #f0f0f0;
		margin-right: 5px;
	}

	#cPanel a span {
		font-size: 10pt;
	}
	#cPanel table {
		width: 99%;
		border-collapse: collapse;
	}
	#cPanel table td{
		white-space: nowrap;
	}
	#cPanel table .config_set{
		padding-right: 20px;
	}

	.radioset {
		margin: 5px 0;
	}

	.un_nowrap {
		white-space: normal !important;
	}

	#system_config {
		table-layout: auto !important;
		line-height: 1.5;
	}
	#system_config td{
/*		white-space: normal !important;*/
	}

	span.required {
		color: #c00;
		font-weight: bold;
	}
	th span.required {
		padding-left: .5em;
	}
	table em {
		font-style: normal;
		font-weight: bold;
		color: #00c;
	}
	table b {
		color: #c0c;
	}
	table tr.bg th {
		text-align: left;
		padding: .5em 1em !important;
	}

	table table.innertable{
		width: auto !important;
		table-layout: auto !important;
	}
	table table.innertable td{
		border: 0 !important;
	}

	.monofont {
		font-family: "Osaka-mono", "MS Gothic", monospace !important;
	}
	.mailtpl_p {
		width: 60em;
		height: 10em;
	}
	.mailtpl_k {
		width: 30em;
		height: 10em;
	}
	.mailtpl_s {
		width: 60em;
		height: 10em;
	}

	a.textlink {
		display: inline-block;
	}
	a.textlink span.ui-icon{
		float: left;
	}

	#add {
		text-align: center;
		cursor: pointer;
		padding: .5em 0;
	}
	#save_result {
		margin-bottom: 10px;
		padding: 5px;
	}
	.ui-state-error p {
		overflow: hidden;
		padding: .3em;
		line-height: 16px;
	}
	.ui-state-error .ui-icon {
		float: left;
		margin-right: 3px;
	}

	.red {
		color: #c00;
	}

	.alert_message {
		margin-bottom: .5em;
	}
	.loading {
		background: url('./common/admin/images/loading.gif') no-repeat left center ;
		min-height: 16px;
		line-height: 16px;
		padding: 4px 0px 3px 21px;
		display: none;
	}
	#notSave{
		color: #fff;
		font-weight: bold;
		white-space: nowrap;
		margin-left: .5em;
		background: #f00;
		display: inline-block;
		display: none;
		padding: 3px;
		border: 1px solid #c00;
		margin-right: 1em;
	}
	#wrapper .ui-state-error {
		background: #FEE;
		color: #FF0084;
		border-width: 2px;
	}
	table table.innertable.addborder td{
		border: 1px solid #ccc !important;
	}
	input.sizepreview {
		width: 30px;
	}
	#sizepreview .default {
		text-align: center;
	}

</style>

</head>
<body>
<?php if($error):?>
<script type="text/javascript">
// エラーがあれば「まだ保存されていません」を表示
// さらにエラー行をエラーカラーにする
jQuery(function($){
	$('#notSave').css('display','inline-block');
	$('form .ui-state-error').each(function(i,e){
		// $(e).closest('tr').find('>th').css({'background-color': $(e).css('background-color')});
		$(e).closest('tr').css({'background-color': $(e).css('background-color')});
	})
})
execBeforeUnload = true;
</script>
<?php endif;?>
<?php if(isset($save_result)):?>
<script type="text/javascript">
execBeforeUnload = false ;
alert('保存しました');
location.href = location.href ;
</script>
<?php endif;?>
<div id="cPanel">
	<table>
		<tbody>
			<tr>
				<td width="220"><h1>メールフォームPHP管理画面</h1></td>
				<td width="300">
					<a href="<?php echo $action;?>?mode=form_config" class="button form_config">フォーム設定</a>
					<a href="<?php echo $action;?>?mode=system_config" class="button system_config">システム設定</a>
					<a href="javascript:void(0)" class="button save_action">保存</a>
					<span id="notSave">まだ保存されていません</span>
				</td>
				<td width="*" class="link_set" align="right">
					<a href="#passwd" class="button passwd_link ui-state-highlight">パスワード変更</a>
					<a href="./" class="button form_link blank ui-state-highlight">フォームを確認</a>
					<a href="<?php echo $action;?>?logout=<?php echo time();?>" class="button logout ui-state-error">ログアウト</a>
				</td>
			</tr>
		</tbody>
	</table>
	<div id="switcher"></div>
</div>
<div id="wrapper" style="display:none">
	<?php if(array_key_exists('save', $error)):?>
	<div class="ui-state-error alert_message"><span class="ui-icon ui-icon-alert" style="float: left"></span><?php echo nl2br($error['save']);?></div>
	<?php endif;?>

	<?php if(isFormConfig):?>
	<form id="form_config" action="<?php echo $action;?>?mode=form_config" method="post">
		<table id="tableHeader">
			<thead>
				<tr>
					<th>No.</th>
					<th>項目名<span class="required">【必須】</span></th>
					<th>必須</th>
					<th>セット/タイプ<span class="required">【必須】</span></th>
					<th>選択肢</th>
					<th>コメント前/後</th>
					<th>入力制限オプション</th>
					<th>変換オプション</th>
					<th>出力オプション</th>
				</tr>
			</thead>
		</table>
		<ul id="sortable">
		<?php foreach($m->setting as $k=>$v): ?>
			<li>
				<table>
					<tbody>
						<tr>
							<td><?php echo $k+1;?></td>
							<td>
<?php if($error[$k]['title']):?>
								<div class="ui-state-error ui-corner-all">
									<p><span class="ui-icon ui-icon-alert"></span><?php echo $error[$k]['title'];?></p>
								</div>
<?php endif; ?>
								<input type="text" name="title[]" value="<?php echo $v['title'];?>" /><br>
								<a href="javascript:void(0);" class="textlink delete"><span class="ui-icon ui-icon-circle-close"></span>この項目を削除する</a>
							</td>
							<td>
								<input type="checkbox" <?php echo $v['required']=='yes'?' checked="checked"':'';?> />
								<input type="hidden" name="required[]" value="<?php echo $v['required']=='yes'?'yes':'no';?>" />
							</td>
							<td>
<?php if($error[$k]['formtype']):?>
								<div class="ui-state-error ui-corner-all">
									<p><span class="ui-icon ui-icon-alert"></span><?php echo $error[$k]['formtype'];?></p>
								</div>
<?php endif; ?>
								<script type="text/javascript">
								jQuery(function($){
									formtype($('#sortable li:eq(<?php echo $k;?>)'),'<?php echo 'setname:'.$v['setname'];?>','<?php echo 'type:'.$v['type'];?>');
								})
								</script>
								<select name="formtype[]">
									<option value="">以下より選択してください</option>
									<optgroup label="フォームセット">
										<option value="setname:name1">氏＋名</option>
										<option value="setname:name2">姓＋名</option>
										<option value="setname:name1_kata">シ＋メイ</option>
										<option value="setname:name2_kata">セイ＋メイ</option>
										<option value="setname:name1_hira">し＋めい</option>
										<option value="setname:name2_hira">せい＋めい</option>
										<option value="setname:mail1">メールアドレス</option>
										<option value="setname:mail2">メールアドレス（確認用入力有）</option>
										<option value="setname:tel1">電話番号（入力欄１つ）</option>
										<option value="setname:tel2">電話番号（入力欄３つ）</option>
										<option value="setname:url1">URL</option>
										<option value="setname:address1">住所セット１（〒入力欄1つ）</option>
										<option value="setname:address2">住所セット２（〒入力欄1つ）</option>
										<option value="setname:address3">住所セット３（〒入力欄2つ）</option>
										<option value="setname:address4">住所セット４（〒入力欄2つ）</option>
										<option value="setname:file1">画像アップロード</option>
										<option value="setname:file2">ファイルアップロード</option>
									</optgroup>
									<optgroup label="フォームタイプ">
										<option value="type:input_text">1行入力欄</option>
										<option value="type:textarea">複数行入力欄</option>
										<option value="type:input_radio">ラジオ</option>
										<option value="type:input_checkbox">チェックボックス</option>
										<option value="type:select">プルダウン</option>
									</optgroup>
								</select>
								<div>
<?php if($__thanks_mail_use):?>
<?php endif;?>
									<div class="setname-mail1 setname-mail2">
										<label><input type="checkbox" <?php echo $v['recipients']=='yes'?' checked="checked"':'';?> /> 確認メールの送信先として使用する</label>
										<input type="hidden" name="recipients[]" value="<?php echo $v['recipients']=='yes'?'yes':'no';?>" />
									</div>
									<div class="setname-address1 setname-address2 setname-address3 setname-address4">
										<p class="indent">※郵便番号検索が付きます。</p>
									</div>
									<div class="setname-address1">
										<p class="indent">※郵便番号＋都道府県＋以下住所・番地＋建物名</p>
										<p class="indent">※郵便番号の入力欄は1つになります。</p>
										<p class="indent">※必須にすると郵便番号＋都道府県＋以下住所・番地が対象となります。</p>
									</div>
									<div class="setname-address2">
										<p class="indent">※郵便番号＋都道府県＋市区町村＋以下住所・番地＋建物名</p>
										<p class="indent">※郵便番号の入力欄は1つになります。</p>
										<p class="indent">※必須にすると郵便番号＋都道府県＋市区町村＋以下住所・番地が対象となります。</p>
									</div>
									<div class="setname-address3">
										<p class="indent">※郵便番号＋都道府県＋以下住所・番地＋建物名</p>
										<p class="indent">※郵便番号の入力欄は2つになります。</p>
										<p class="indent">※必須にすると郵便番号＋都道府県＋以下住所・番地が対象となります。</p>
									</div>
									<div class="setname-address4">
										<p class="indent">※郵便番号＋都道府県＋市区町村＋以下住所・番地＋建物名</p>
										<p class="indent">※郵便番号の入力欄は2つになります。</p>
										<p class="indent">※必須にすると郵便番号＋都道府県＋市区町村＋以下住所・番地が対象となります。</p>
									</div>
									<div class="setname-file1">
										<p class="indent">※確認画面でアップロードされた画像がプレビューが表示されます。</p>
									</div>
									<div class="setname-file2">
										<p class="indent">※確認画面でアップロードされたファイル名が表示されます。</p>
									</div>
									<div class="setname-file1 setname-file2">
										<p class="indent">※アップロードを許可する拡張子の設定やアップロード容量の制限は入力制限オプションより行なって下さい。</p>
										<p class="indent">※アップロードされたファイルは通知用メールに添付ではなく、ダウンロードURLが記載されますのでそちらからダウンロードできます。</p>
										<p class="indent">※スマートフォン、携帯では非表示となります。</p>
									</div>
									<div class="type-input_text">
<?php if($error[$k]['size']):?>
										<div class="ui-state-error ui-corner-all">
											<p><span class="ui-icon ui-icon-alert"></span><?php echo $error[$k]['size'];?></p>
										</div>
<?php endif; ?>
										入力欄のサイズ：<input type="text" name="size[]" style="text-align:right;width:30px" value="<?php echo sprintf('%d',$v['size']);?>" maxlength="3" autocomplete="off" />
										<p class="indent">※指定が無い場合はシステム設定の設定値が挿入されます。</p>
									</div>
									<div class="type-textarea">
<?php if($error[$k]['cols']):?>
										<div class="ui-state-error ui-corner-all">
											<p><span class="ui-icon ui-icon-alert"></span><?php echo $error[$k]['cols'];?></p>
										</div>
<?php endif; ?>
<?php if($error[$k]['rows']):?>
										<div class="ui-state-error ui-corner-all">
											<p><span class="ui-icon ui-icon-alert"></span><?php echo $error[$k]['rows'];?></p>
										</div>
<?php endif; ?>
										入力欄の幅：<input type="text" name="cols[]" style="text-align:right;width:30px" value="<?php echo sprintf('%d',$v['cols']);?>" maxlength="3" autocomplete="off" />　高さ：<input type="text" name="rows[]" style="text-align:right;width:30px" value="<?php echo sprintf('%d',$v['rows']);?>" maxlength="3" autocomplete="off" />
										<p class="indent">※指定が無い場合はシステム設定の設定値が挿入されます。</p>
									</div>
								</div>
							</td>
							<td>
								<input type="hidden" name="select_values[]" value="<?php echo str_replace($replace_after,$replace_before,$v['select_values']);?>" />
								<textarea><?php echo str_replace($replace_after,$replace_before,$v['select_values']);?></textarea><br>
								<a href="javascript:void(0);" class="textlink modal"><span class="ui-icon ui-icon-newwin"></span>大きな入力欄で設定する</a>
							</td>
							<td>
								<input type="text" name="comment_before[]" class="input_comment" value="<?php echo htmlspecialchars($v['comment_before']);?>" /><br>
								<input type="text" name="comment_after[]" class="input_comment" value="<?php echo htmlspecialchars($v['comment_after']);?>" />
								<p class="indent">※HTMLタグ使用可</p>
							</td>
							<td>
								<div>
									<button class="options"><em>0</em>個</button>
									<button class="modal">設定</button>
									<input type="hidden" name="check_options[]" value="<?php echo $v['check_options'];?>" />
								</div>
							</td>
							<td>
								<div>
									<button class="options"><em>0</em>個</button>
									<button class="modal">設定</button>
									<input type="hidden" name="output_options[]" value="<?php echo $v['output_options'];?>" />
								</div>
							</td>
							<td>
								<div>
									<button class="options"><em>0</em>個</button>
									<button class="modal">設定</button>
									<input type="hidden" name="convert_options[]" value="<?php echo $v['convert_options'];?>" />
								</div>
							</td>
						</tr>
					</tbody>
				</table>
			</li>
		<?php endforeach; ?>
		</ul>
	</form>
	<ul>
		<li id="add" class="ui-state-default">
			項目を１つ追加する
			<table id="datatable-sample">
				<tbody>
					<tr>
						<td></td>
						<td>
							<input type="text" name="title[]" value="" /><br>
							<a href="javascript:void(0);" class="textlink delete"><span class="ui-icon ui-icon-circle-close"></span>この項目を削除する</a>
						</td>
						<td>
							<input type="checkbox" />
							<input type="hidden" name="required[]" value="no" />
						</td>
						<td>
							<select name="formtype[]">
								<option>以下より選択してください</option>
								<optgroup label="フォームセット">
									<option value="setname:name1">氏＋名</option>
									<option value="setname:name2">姓＋名</option>
									<option value="setname:name1_kata">シ＋メイ</option>
									<option value="setname:name2_kata">セイ＋メイ</option>
									<option value="setname:name1_hira">し＋めい</option>
									<option value="setname:name2_hira">せい＋めい</option>
									<option value="setname:mail1">メールアドレス</option>
									<option value="setname:mail2">メールアドレス（確認用にも入力欄）</option>
									<option value="setname:tel1">電話番号（入力欄１つ）</option>
									<option value="setname:tel2">電話番号（入力欄３つ）</option>
									<option value="setname:url1">URL</option>
									<option value="setname:address1">住所セット１（〒入力欄1つ）</option>
									<option value="setname:address2">住所セット２（〒入力欄1つ）</option>
									<option value="setname:address3">住所セット３（〒入力欄2つ）</option>
									<option value="setname:address4">住所セット４（〒入力欄2つ）</option>
									<option value="setname:file1">画像アップロード</option>
									<option value="setname:file2">ファイルアップロード</option>
								</optgroup>
								<optgroup label="フォームタイプ">
									<option value="type:input_text">1行入力欄</option>
									<option value="type:textarea">複数行入力欄</option>
									<option value="type:input_radio">ラジオ</option>
									<option value="type:input_checkbox">チェックボックス</option>
									<option value="type:select">プルダウン</option>
								</optgroup>
							</select>
							<div>
<?php if($__thanks_mail_use):?>
<?php endif;?>
								<div class="setname-mail1 setname-mail2">
									<label><input type="checkbox" /> 確認メールの送信先として使用する</label>
									<input type="hidden" name="recipients[]" value="no" />
								</div>
								<div class="setname-address1 setname-address2 setname-address3 setname-address4">
									<p class="indent">※郵便番号検索が付きます。</p>
								</div>
								<div class="setname-address1">
									<p class="indent">※郵便番号＋都道府県＋以下住所・番地＋建物名</p>
									<p class="indent">※郵便番号の入力欄は1つになります。</p>
									<p class="indent">※必須にすると郵便番号＋都道府県＋以下住所・番地が対象となります。</p>
								</div>
								<div class="setname-address2">
									<p class="indent">※郵便番号＋都道府県＋市区町村＋以下住所・番地＋建物名</p>
									<p class="indent">※郵便番号の入力欄は1つになります。</p>
									<p class="indent">※必須にすると郵便番号＋都道府県＋市区町村＋以下住所・番地が対象となります。</p>
								</div>
								<div class="setname-address3">
									<p class="indent">※郵便番号＋都道府県＋以下住所・番地＋建物名</p>
									<p class="indent">※郵便番号の入力欄は2つになります。</p>
									<p class="indent">※必須にすると郵便番号＋都道府県＋以下住所・番地が対象となります。</p>
								</div>
								<div class="setname-address4">
									<p class="indent">※郵便番号＋都道府県＋市区町村＋以下住所・番地＋建物名</p>
									<p class="indent">※郵便番号の入力欄は2つになります。</p>
									<p class="indent">※必須にすると郵便番号＋都道府県＋市区町村＋以下住所・番地が対象となります。</p>
								</div>
								<div class="setname-file1">
									<p class="indent">※確認画面でアップロードされた画像がプレビューが表示されます。</p>
								</div>
								<div class="setname-file2">
									<p class="indent">※確認画面でアップロードされたファイル名が表示されます。</p>
								</div>
								<div class="setname-file1 setname-file2">
									<p class="indent">※アップロードを許可する拡張子の設定やアップロード容量の制限は入力制限オプションより行なって下さい。</p>
									<p class="indent">※アップロードされたファイルは通知用メールに添付ではなく、ダウンロードURLが記載されますのでそちらからダウンロードできます。</p>
									<p class="indent">※スマートフォン、携帯では非表示となります。</p>
								</div>
								<div class="type-input_text">
									入力欄のサイズ：<input type="text" name="size[]" style="text-align:right;width:30px" value="" maxlength="3" autocomplete="off" />
									<p class="indent">※指定が無い場合はシステム設定の設定値が挿入されます。</p>
								</div>
								<div class="type-textarea">
									入力欄の幅：<input type="text" name="cols[]" style="text-align:right;width:30px" value="" maxlength="3" autocomplete="off" />　高さ：<input type="text" name="rows[]" style="text-align:right;width:30px" value="" maxlength="3" autocomplete="off" />
									<p class="indent">※指定が無い場合はシステム設定の設定値が挿入されます。</p>
								</div>
							</div>
						</td>
						<td>
							<input type="hidden" name="select_values[]" value="" />
							<textarea></textarea><br />
							<a href="javascript:void(0);" class="textlink modal"><span class="ui-icon ui-icon-newwin"></span>大きな入力欄で設定する</a>
						</td>
						<td>
							<input type="text" name="comment_before[]" value="" class="input_comment" /><br>
							<input type="text" name="comment_after[]" value="" class="input_comment" />
							<p class="indent">※HTMLタグ使用可</p>
						</td>
						<td>
							<div>
								<button class="options"><em>0</em>個</button>
								<button class="modal">設定</button>
								<input type="hidden" name="output_options[]" value="" />
							</div>
						</td>
						<td>
							<div>
								<button class="options"><em>0</em>個</button>
								<button class="modal">設定</button>
								<input type="hidden" name="convert_options[]" value="" />
							</div>
						</td>
						<td>
							<div>
								<button class="options"><em>0</em>個</button>
								<button class="modal">設定</button>
								<input type="hidden" name="check_options[]" value="" />
							</div>
						</td>
					</tr>
				</tbody>
			</table>
		</li>
	</ul>
	<?php //var_dump($m->setting);?>
	<?php endif;?>

	<?php if(isSystemConfig):?>
	<form id="system_config" action="<?php echo $action;?>?mode=system_config" method="post">
		<table style="table-layout:auto">
			<colgroup width="180"></colgroup>
			<colgroup width="*"></colgroup>
			<colgroup width="300"></colgroup>
			<tbody>
				<tr class="bg">
					<th colspan="2">情報</th>
					<th>ヘルプ</th>
				</tr>
				<tr>
					<th>メールフォームPHPのバージョン</th>
					<td><?php echo MAILFORMPHP_VERSION;?></td>
					<td>-</td>
				</tr>
				<tr>
					<th>PHPのバージョン</th>
					<td>
						<?php echo implode('.',$version);?>
						<?php if (PHP_MAJOR_VERSION>=5&&PHP_MINOR_VERSION>=2&&PHP_RELEASE_VERSION>=1):?>
						<?php else: ?>
						<p class="indent">※このバージョンでは一部エンコードに未対応な為、「<b>はしごたか（髙）</b>」や「<b>まるいち（①）</b>」等の文字がメール内で化けます。</p>
						<p class="indent">※ただし以下の文字に対しては代替え文字に置換します。</p>
						<div style="overflow:auto;height:100px;width:150px;">
							<table class="innertable" style="width:100%;">
								<thead>
									<tr>
										<th>変換前</th>
										<th>変換後</th>
									</tr>
								</thead>
								<tbody>
									<?php
										$dCode = new dependentCode;
										$tr = 1;
										foreach($dCode->getList() as $before => $after):
									?>
									<tr style="background:<?php echo $tr%2==0?'#fff':'#f0f0f0'; $tr++; ?>">
										<td width="50%" align="center"><?php echo $before; ?></td>
										<td width="50%" align="center"><?php echo $after; ?></td>
									</tr>
									<?php endforeach; ?>
								</tbody>
							</table>
						</div>
						<?php endif; ?>
					</td>
					<td>
						※5.2.1以上推奨
					</td>
				</tr>
				<tr>
					<th>PHPの動作モード</th>
					<td>
						<?php echo getSapiType(); ?>
					</td>
					<td>-</td>
				</tr>
				<tr>
					<th>モジュール一覧</th>
					<td>
						<?php
							$required_modules = array('mbstring');
							$modules = get_loaded_extensions();
							foreach($modules as $i => $module){
								if(array_search($module,$required_modules)!==false){
									$module = '<b>' . $module . '</b>';
								}
								echo ($i>0?', ':'') . ($i>0&&$i%10==0?'<br />':'') . $module ;
							}
						?>
					</td>
					<td>
						必須モジュール<br />
						<ul>
							<?php foreach($required_modules as $required_module):?>
							<li><b><?php echo $required_module; ?></b></li>
							<?php endforeach; ?>
						</ul>
					</td>
				</tr>
				<tr>
					<th>IPアドレス</th>
					<td>
						<?php echo $_SERVER['REMOTE_ADDR'];?>
					</td>
					<td>
						-
					</td>
				</tr>
				<tr>
					<th>ブラウザ情報</th>
					<td>
						<?php echo $_SERVER['HTTP_USER_AGENT'];?>
					</td>
					<td>
						-
					</td>
				</tr>
				<tr>
					<th>最終送信番号</th>
					<td>
						<?php echo ($counter>0?$counter.'　(最終更新日: '.date('Y-m-d H:i:s',$counter_modified).')':'フォームの利用はありません');?>
					</td>
					<td>
						-
					</td>
				</tr>
				<tr class="bg">
					<th colspan="2">基本設定</th>
					<th>ヘルプ</th>
				</tr>
				<tr>
					<th>フォームのURL<span class="required">【必須】</span></th>
					<td>
						<p><input type="text" name="base_url" id="base_url" placeholder="例：http://www.example.com/form/" style="width:300px;" /></p>
<?php if(array_key_exists('base_url',$error)):?>
						<div class="ui-state-error ui-corner-all">
							<p><span class="ui-icon ui-icon-alert"></span><?php echo $error['base_url'];?></p>
						</div>
<?php endif; ?>
						<p>現在のURLでの入力例：<?php echo $example_url;?></p>
					</td>
					<td class="un_nowrap">
						フォームがあるディレクトリのURLを設定して下さい。（最後は/で終わって下さい）
					</td>
				</tr>
				<tr>
					<th>利用者判別</th>
					<td>
						<div class="radioset">
							<input type="radio" name="template_type" id="template_type_1" value="1" /><label for="template_type_1">自動判別</label>
							<input type="radio" name="template_type" id="template_type_2" value="2" /><label for="template_type_2">PC用</label>
							<input type="radio" name="template_type" id="template_type_3" value="3" /><label for="template_type_3">携帯用</label>
							<input type="radio" name="template_type" id="template_type_4" value="4" /><label for="template_type_4">スマートフォン用</label>
						</div>
<?php if(array_key_exists('template_type',$error)):?>
						<div class="ui-state-error ui-corner-all">
							<p><span class="ui-icon ui-icon-alert"></span><?php echo $error['template_type'];?></p>
						</div>
<?php endif; ?>
					</td>
					<td class="un_nowrap">
						<p>デフォルト：<em>自動判別</em></p>
						<br>
						フォーム利用者の環境を問わず、表示方法を固定したい場合に利用します。自動判別の場合はユーザーエージェントによる判別を行います。（帯域での判別は行いません）
					</td>
				</tr>
				<tr>
					<th>テンプレートの文字コード</th>
					<td>
						<p>■PC用</p>
						<div class="radioset">
							<input type="radio" name="template_mojicode_p" id="template_mojicode_p_u" value="1" /><label for="template_mojicode_p_u">UTF-8</label>
							<input type="radio" name="template_mojicode_p" id="template_mojicode_p_s" value="2" /><label for="template_mojicode_p_s">Shift_JIS</label>
							<input type="radio" name="template_mojicode_p" id="template_mojicode_p_e" value="3" /><label for="template_mojicode_p_e">EUC-JP</label>
						</div>
<?php if(array_key_exists('template_mojicode_p',$error)):?>
						<div class="ui-state-error ui-corner-all">
							<p><span class="ui-icon ui-icon-alert"></span><?php echo $error['template_mojicode_p'];?></p>
						</div>
<?php endif; ?>
						<p>■携帯用</p>
						<div class="radioset">
							<input type="radio" name="template_mojicode_k" id="template_mojicode_k_u" value="1" /><label for="template_mojicode_k_u">UTF-8</label>
							<input type="radio" name="template_mojicode_k" id="template_mojicode_k_s" value="2" /><label for="template_mojicode_k_s">Shift_JIS</label>
							<input type="radio" name="template_mojicode_k" id="template_mojicode_k_e" value="3" /><label for="template_mojicode_k_e">EUC-JP</label>
						</div>
<?php if(array_key_exists('template_mojicode_k',$error)):?>
						<div class="ui-state-error ui-corner-all">
							<p><span class="ui-icon ui-icon-alert"></span><?php echo $error['template_mojicode_k'];?></p>
						</div>
<?php endif; ?>
						<p>■スマートフォン用</p>
						<div class="radioset">
							<input type="radio" name="template_mojicode_s" id="template_mojicode_s_u" value="1" /><label for="template_mojicode_s_u">UTF-8</label>
							<input type="radio" name="template_mojicode_s" id="template_mojicode_s_s" value="2" /><label for="template_mojicode_s_s">Shift_JIS</label>
							<input type="radio" name="template_mojicode_s" id="template_mojicode_s_e" value="3" /><label for="template_mojicode_s_e">EUC-JP</label>
						</div>
<?php if(array_key_exists('template_mojicode_s',$error)):?>
						<div class="ui-state-error ui-corner-all">
							<p><span class="ui-icon ui-icon-alert"></span><?php echo $error['template_mojicode_s'];?></p>
						</div>
<?php endif; ?>
					</td>
					<td class="un_nowrap">
						<p>
							デフォルト<br>
							PC用：<em>UTF-8</em><br>
							携帯用：<em>UTF-8</em><br>
							スマートフォン用：<em>UTF-8</em>
						</p>
						<br>
						他のページに合わせてエンコードを変更する場合に利用します。「利用者判別」で表示方法を固定している場合は固定した物のみ利用します。
					</td>
				</tr>
				<tr>
					<th>ファイルダウンロード用キー</th>
					<td>
						<p><input type="text" name="downloadkey" id="downloadkey" style="width:150px;" /></p>
<?php if(array_key_exists('downloadkey',$error)):?>
						<div class="ui-state-error ui-corner-all">
							<p><span class="ui-icon ui-icon-alert"></span><?php echo $error['downloadkey'];?></p>
						</div>
<?php endif; ?>
					</td>
					<td class="un_nowrap">
						ファイルをダウンロードする場合に使用します。空欄の場合はファイルのダウンロードが行えませんので、画像アップロード、ファイルアップロード利用時は必ず設定して下さい。
					</td>
				</tr>
				<tr>
					<th>入力欄の大きさ</th>
					<td>
						<script type="text/javascript">
						jQuery(function($){
							var input_size_default = 30,
								textarea_cols_default = 30,
								textarea_rows_default = 10,
								target = {
									'size': 'input',
									'cols': 'textarea',
									'rows': 'textarea'
								}

							$.each(target, function(name,tag){
								$('#sizepreview .sizepreview[name^="'+name+'"]').each(function(i,e){
									var $self = $(e),
										$tr = $self.closest('tr'),
										$def = $tr.find('.default');

									if ($def.html()=='') {
										$def.html( default_ini[$self.attr('name')] );
									} else {
										$def.html( $def.html()+'/'+default_ini[$self.attr('name')] );
									}

									var resize = function(){
										var size = input_size_default;
										if ( $self.val().match(/^\d+$/) ) {
											size = $self.val();
										}
										$tr.find('.sizeresult '+tag).attr(name, size);
									}
									$self.focus(resize).blur(resize).change(resize)
										.keyup(function(event){
											var V = keyCalc(event, $self);
											if (V) {
												$self.val(V);
												resize();
											}
										})
									resize();
								})
							})
						})
						</script>
						<table class="innertable addborder" id="sizepreview">
							<tbody>
								<tr>
									<td colspan="2">セット/タイプ</td>
									<td>初期値</td>
									<td>設定値</td>
									<td>サイズプレビュー</td>
								</tr>
								<tr>
									<td colspan="2">氏(姓)＋名</td>
									<td class="default"></td>
									<td>
										size="<input type="text" name="size_name" id="size_name" class="sizepreview" maxlength="10" autocomplete="off" />"(共通)
									</td>
									<td class="sizeresult"><input type="text" size="30" style="width:none" placeholder="鈴木" /> <input type="text" size="30" style="width:none" placeholder="一郎" /></td>
								</tr>
								<tr>
									<td colspan="2">し(せい)＋めい, シ(セイ)＋メイ</td>
									<td class="default"></td>
									<td>
										size="<input type="text" name="size_namehira" id="size_namehira" class="sizepreview" maxlength="10" autocomplete="off" />"(共通)
									</td>
									<td class="sizeresult"><input type="text" size="30" style="width:none" placeholder="すずき" /> <input type="text" size="30" style="width:none" placeholder="いちろう" /></td>
								</tr>
								<tr>
									<td colspan="2">メールアドレス</td>
									<td class="default"></td>
									<td>
										size="<input type="text" name="size_mail" id="size_mail" class="sizepreview" maxlength="255" autocomplete="off" />"
									</td>
									<td class="sizeresult"><input type="text" size="30" style="width:none" placeholder="info@example.com" /></td>
								</tr>
								<tr>
									<td rowspan="2">電話番号</td>
									<td>入力欄1つ</td>
									<td class="default"></td>
									<td>
										size="<input type="text" name="size_tel1" id="size_tel1" class="sizepreview" maxlength="13" autocomplete="off" />"
									</td>
									<td class="sizeresult"><input type="text" size="30" style="width:none" placeholder="000-000-0000" /></td>
								</tr>
								<tr>
									<td>入力欄3つ</td>
									<td class="default"></td>
									<td>
										size="<input type="text" name="size_tel3" id="size_tel3" class="sizepreview" maxlength="3" autocomplete="off" />"(共通)
									</td>
									<td class="sizeresult"><input type="text" size="30" style="width:none" placeholder="000" />-<input type="text" size="30" style="width:none" placeholder="000" />-<input type="text" size="30" style="width:none" placeholder="0000" /></td>
								</tr>
								<tr>
									<td rowspan="3">郵便番号</td>
									<td>入力欄1つ</td>
									<td class="default"></td>
									<td>
										size="<input type="text" name="size_zip" id="size_zip" class="sizepreview" maxlength="8" autocomplete="off" />"
									</td>
									<td class="sizeresult"><input type="text" size="30" style="width:none" placeholder="000-0000" /></td>
								</tr>
								<tr>
									<td>入力欄2つ時の左(3桁)</td>
									<td class="default"></td>
									<td>
										size="<input type="text" name="size_zip1" id="size_zip1" class="sizepreview" maxlength="3" autocomplete="off" />"
									</td>
									<td class="sizeresult"><input type="text" size="30" style="width:none" placeholder="000" /></td>
								</tr>
								<tr>
									<td>入力欄2つ時の右(4桁)</td>
									<td class="default"></td>
									<td>
										size="<input type="text" name="size_zip2" id="size_zip2" class="sizepreview" maxlength="4" autocomplete="off" />"
									</td>
									<td class="sizeresult"><input type="text" size="30" style="width:none" placeholder="0000" /></td>
								</tr>
								<tr>
									<td rowspan="3">住所セット</td>
									<td>市区町村</td>
									<td class="default"></td>
									<td>
										size="<input type="text" name="size_city" id="size_city" class="sizepreview" maxlength="20" autocomplete="off" />"
									</td>
									<td class="sizeresult"><input type="text" size="30" style="width:none" placeholder="△△市△△区" /></td>
								</tr>
								<tr>
									<td>以下住所・番地</td>
									<td class="default"></td>
									<td>
										size="<input type="text" name="size_addr" id="size_addr" class="sizepreview" maxlength="50" autocomplete="off" />"
									</td>
									<td class="sizeresult"><input type="text" size="30" style="width:none" placeholder="△△1-2-3" /></td>
								</tr>
								<tr>
									<td>ビル・建物名等</td>
									<td class="default"></td>
									<td>
										size="<input type="text" name="size_bldg" id="size_bldg" class="sizepreview" maxlength="50" autocomplete="off" />"
									</td>
									<td class="sizeresult"><input type="text" size="30" style="width:none" placeholder="△△マンション1階" /></td>
								</tr>
								<tr>
									<td colspan="2">1行入力欄</td>
									<td class="default"></td>
									<td>
										size="<input type="text" name="size_input" id="size_input" class="sizepreview" maxlength="100" autocomplete="off" />"
									</td>
									<td class="sizeresult"><input type="text" size="30" style="width:none" placeholder="ダミーテキスト" /></td>
								</tr>
								<tr>
									<td colspan="2">複数行入力欄</td>
									<td class="default"></td>
									<td>
										cols="<input type="text" name="cols_textarea" id="cols_textarea" class="sizepreview" maxlength="100" autocomplete="off" />"<br />rows="<input type="text" name="rows_textarea" id="rows_textarea" class="sizepreview" maxlength="3" autocomplete="off" />"
									</td>
									<td class="sizeresult"><textarea cols="30" rows="10" style="height:auto;width:auto;line-height:1" placeholder="ここにテキストが入力されます。これはダミーテキストです。"></textarea></td>
								</tr>
							</tbody>
						</table>
<?php if(array_key_exists('size_mail',$error)):?>
						<div class="ui-state-error ui-corner-all">
							<p><span class="ui-icon ui-icon-alert"></span><?php echo $error['size_mail'];?></p>
						</div>
<?php endif; ?>
					</td>
					<td class="un_nowrap">
						フォームの入力欄の大きさを設定できます。<br />
						OSやブラウザによってサイズが異なる場合がありますので余裕のある設定値にされる事をお勧め致します。<br />
						<br />
						size, cols, rowsの最小値と最大値<br />
						<table style="width:150px;">
							<colgroup width="100"></colgroup>
							<colgroup width="*"></colgroup>
							<tbody>
								<tr>
									<th>最小値</th>
									<td align="right">1</td>
								</tr>
								<tr>
									<th>最大値</th>
									<td align="right">100</td>
								</tr>
							</tbody>
						</table>
						<br />
						キーボードショートカット<br />
						<table style="width:150px;">
							<colgroup width="100"></colgroup>
							<colgroup width="*"></colgroup>
							<tbody>
								<tr>
									<th>↑</th>
									<td align="right">+ 1</td>
								</tr>
								<tr>
									<th>↓</th>
									<td align="right">- 1</td>
								</tr>
								<tr>
									<th>Shift + ↑</th>
									<td align="right">+ 10</td>
								</tr>
								<tr>
									<th>Shift + ↓</th>
									<td align="right">- 10</td>
								</tr>
							</tbody>
						</table>
					</td>
				</tr>
				<tr class="bg">
					<th colspan="2">利用者への確認メール設定</th>
					<th>ヘルプ</th>
				</tr>
				<tr>
					<th>利用設定</th>
					<td>
						<div class="radioset">
							<input type="radio" name="thanks_mail_use" id="thanks_mail_use_1" value="1" /><label for="thanks_mail_use_1">利用する</label>
							<input type="radio" name="thanks_mail_use" id="thanks_mail_use_2" value="2" /><label for="thanks_mail_use_2">利用しない</label>
						</div>
<?php if(array_key_exists('thanks_mail_use',$error)):?>
						<div class="ui-state-error ui-corner-all">
							<p><span class="ui-icon ui-icon-alert"></span><?php echo $error['thanks_mail_use'];?></p>
						</div>
<?php endif; ?>
<?php if($found_mail_setting===false):?>
						<div class="ui-state-error ui-corner-all">
							<p><span class="ui-icon ui-icon-alert"></span>利用者への確認メール設定を利用する場合はフォーム設定内に必ず１つはメールアドレスの項目が必要です。</p>
						</div>
<?php endif; ?>
<?php if($found_recipients_yes===false):?>
						<div class="ui-state-error ui-corner-all">
							<p><span class="ui-icon ui-icon-alert"></span>利用者への確認メール設定を利用する場合はフォーム設定内の「確認メールの送信先として使用する」に必ず１つチェックを入れて下さい。</p>

						</div>
<?php endif; ?>
					</td>
					<td class="un_nowrap">
						<p>デフォルト：<em>利用する</em></p>
						<br>
						フォームを利用した方へ入力内容の確認メールを送信するか否かを設定できます。<b>利用する</b>にした場合、フォーム設定で<b>メールアドレス</b>の利用が必須となります。
					</td>
				</tr>
				<tr>
					<th>送信元<span class="required">【必須】</span></th>
					<td>
						<p>■名称とメールアドレス</p>
						<p><input type="text" name="thanks_mail_from_name" id="thanks_mail_from_name" placeholder="例：株式会社＊＊＊＊" style="width:100px;" /> &lt;<input type="text" name="thanks_mail_from_mail" id="thanks_mail_from_mail" placeholder="例：info@example.com" style="width:200px;" />&gt;</p>
<?php if(array_key_exists('thanks_mail_from_mail',$error)):?>
						<div class="ui-state-error ui-corner-all">
							<p><span class="ui-icon ui-icon-alert"></span><?php echo $error['thanks_mail_from_mail'];?></p>
						</div>
<?php endif; ?>
						<br>
						<p>■SMTP認証を使用して確認メール、通知メールを送る場合は以下の設定を行なって下さい。</p>
						<div class="radioset">
							SMTP認証を
							<input type="radio" name="thanks_mail_from_smtp_auth" id="thanks_mail_from_smtp_auth_1" value="1" /><label for="thanks_mail_from_smtp_auth_1">利用する</label>
							<input type="radio" name="thanks_mail_from_smtp_auth" id="thanks_mail_from_smtp_auth_2" value="2" /><label for="thanks_mail_from_smtp_auth_2">利用しない</label>
						</div>
						<p>※「利用しない」にして保存すると以下の４項目をクリアします。</p>
<?php if(array_key_exists('thanks_mail_from_smtp_auth',$error)):?>
						<div class="ui-state-error ui-corner-all">
							<p><span class="ui-icon ui-icon-alert"></span><?php echo $error['thanks_mail_from_smtp_auth'];?></p>
						</div>
<?php endif; ?>
						<table class="innertable">
							<tbody>
								<tr>
									<td>
										<p>ホスト名：<input type="text" name="thanks_mail_from_smtp_host" id="thanks_mail_from_smtp_host" style="width:150px" placeholder="例：smtp.example.com" /></p>
										<p>ポート番号：<input type="text" name="thanks_mail_from_smtp_port" id="thanks_mail_from_smtp_port" style="width:50px" placeholder="例：587" /> <a href="javascript:setPort(25)">25</a> <a href="javascript:setPort(587)">587</a> <a href="javascript:setPort(465)">465</a></p>
										<p>ユーザー名：<input type="text" name="thanks_mail_from_smtp_username" id="thanks_mail_from_smtp_username" style="width:150px" placeholder="例：username" /></p>
										<p>パスワード：<input type="password" name="thanks_mail_from_smtp_password" id="thanks_mail_from_smtp_password" style="width:150px" placeholder="例：password" /></p>
									</td>
									<td style="padding-left:15px;">
										<script type="text/javascript">
										function setPort(port){
											var msg = new Array(),
												$target = $('#thanks_mail_from_smtp_port'),
												nowPort = $target.val();
											if (nowPort==port) {
												alert('入力されているポート番号と同じです。');
												return ;
											}
											msg[msg.length] = 'ポート番号：' . port ;
											switch(port){
												case 25:
													msg[msg.length] = '一般的なSMTP用ポート番号です。';
													break;
												case 587:
													msg[msg.length] = 'Outbound Port 25 Blocking(OP25B)環境の場合はこちらのポート番号がよく用いられます。';
													break;
												case 465:
													msg[msg.length] = 'SMTPs用のポート番号です。';
													break;
												default:
													return ;
													break;
											}

											msg[msg.length] = '';
											msg[msg.length] = 'このポート番号を挿入しますか？';
											if (confirm(msg.join("\n"))) {
												$target.val(port);
											}

										}
										function btn_smtpauthtest(disabled){
											$('#test_smtpauth').attr('disabled',disabled).button('refresh');
											return disabled ;
										}
										jQuery(function($){
											$('#test_smtpauth').button().click(function(){
												btn_smtpauthtest(true);
												var $loading = $(this).parent().find('.loading').show();
												var param = {
													host: $('#thanks_mail_from_smtp_host').val(),
													port: $('#thanks_mail_from_smtp_port').val(),
													username: $('#thanks_mail_from_smtp_username').val(),
													password: $('#thanks_mail_from_smtp_password').val()
												};
												$.ajax({
													type: "POST",
													url: "<?php echo $action;?>",
													data: param,
													success: function(data){
														$('#smtpauth_result').hide().queue([]).empty().html(data).show().delay(10000).fadeOut();
														$loading.hide();
														btn_smtpauthtest(false);
													}
												});
												return false;
											})
											var smtp_auth_checkbox = $('[name="thanks_mail_from_smtp_auth"]').change(function(){
												var disabled = $(this).val() == 1 ? false : true ;
												btn_smtpauthtest(disabled);
											})
											if ($('input[name="thanks_mail_from_smtp_auth"]:checked').val()=='2') {
												btn_smtpauthtest(true);
											}
										})
										</script>
										<button id="test_smtpauth">SMTP認証のテスト</button>
										<div class="loading">
											認証テスト開始 ... しばらくお待ち下さい。
										</div>
										<p style="padding-top:.5em;color:red;">テストを行う場合は<br />左の４項目全て入力して下さい</p>
									</td>
								</tr>
							</tbody>
						</table>
						<div id="smtpauth_result" class="ui-state-highlight ui-corner-all" style="padding:5px;display:none">

						</div>
<?php if(array_key_exists('thanks_mail_from_smtp_host',$error)):?>
						<div class="ui-state-error ui-corner-all">
							<p><span class="ui-icon ui-icon-alert"></span><?php echo $error['thanks_mail_from_smtp_host'];?></p>
						</div>
<?php endif; ?>
<?php if(array_key_exists('thanks_mail_from_smtp_port',$error)):?>
						<div class="ui-state-error ui-corner-all">
							<p><span class="ui-icon ui-icon-alert"></span><?php echo $error['thanks_mail_from_smtp_port'];?></p>
						</div>
<?php endif; ?>
<?php if(array_key_exists('thanks_mail_from_smtp_username',$error)):?>
						<div class="ui-state-error ui-corner-all">
							<p><span class="ui-icon ui-icon-alert"></span><?php echo $error['thanks_mail_from_smtp_username'];?></p>
						</div>
<?php endif; ?>
<?php if(array_key_exists('thanks_mail_from_smtp_password',$error)):?>
						<div class="ui-state-error ui-corner-all">
							<p><span class="ui-icon ui-icon-alert"></span><?php echo $error['thanks_mail_from_smtp_password'];?></p>
						</div>
<?php endif; ?>
					</td>
					<td class="un_nowrap">
						送信元の名称（任意）とメールアドレス（<span class="required">必須</span>）を設定できます。<br>
						また、SMTP認証用設定を行うと、SMTP認証を行なってからメールの送信を行います。<br>
						名称には「<b>企業名</b>」「<b>サイト名</b>」「<b>サービス名</b>」等を、メールアドレスには「<b>代表メールアドレス</b>」「<b>問い合わせ用メールアドレス</b>」等が一般的です。
					</td>
				</tr>
				<tr>
					<th>件名</th>
					<td>
						<input type="text" name="thanks_mail_subject" id="thanks_mail_subject" placeholder="例：お問い合わせありがとうございました" style="width:300px;" />
<?php if(array_key_exists('thanks_mail_subject',$error)):?>
						<div class="ui-state-error ui-corner-all">
							<p><span class="ui-icon ui-icon-alert"></span><?php echo $error['thanks_mail_subject'];?></p>
						</div>
<?php endif; ?>
					</td>
					<td class="un_nowrap">
						確認メールの件名を設定できます。
					</td>
				</tr>
				<tr class="bg">
					<th colspan="2">管理者への通知メール設定</th>
					<th>ヘルプ</th>
				</tr>
				<tr>
					<th>送信元</th>
					<td class="un_nowrap">
						確認メールの送信元を参照しますのでそちらを設定して下さい。
					</td>
					<td class="un_nowrap">
						ヘルプはありません。
					</td>
				</tr>
				<tr>
					<th>件名</th>
					<td>
						<input type="text" name="alert_mail_subject" id="alert_mail_subject" placeholder="例：フォームより問い合わせがありました" style="width:300px;" />
<?php if(array_key_exists('alert_mail_subject',$error)):?>
						<div class="ui-state-error ui-corner-all">
							<p><span class="ui-icon ui-icon-alert"></span><?php echo $error['alert_mail_subject'];?></p>
						</div>
<?php endif; ?>
					</td>
					<td class="un_nowrap">
						通知メールの件名を設定できます。
					</td>
				</tr>
				<tr>
					<th>送信先（A）<span class="required">【必須】</span></th>
					<td>
						<input type="text" name="alert_mail_to1" id="alert_mail_to1" placeholder="例：info@example.com,info2@example.com" style="width:300px;" />
<?php if(array_key_exists('alert_mail_to1',$error)):?>
						<div class="ui-state-error ui-corner-all">
							<p><span class="ui-icon ui-icon-alert"></span><?php echo $error['alert_mail_to1'];?></p>
						</div>
<?php endif; ?>
					</td>
					<td class="un_nowrap">
						フォームの利用があった際に入力内容の全てを指定したメールアドレスに送信します。メールアドレスはカンマ（,）で区切ると宛先を複数指定できます。ただし、複数指定した場合は宛先に指定した全てのアドレスが記載されます。
					</td>
				</tr>
				<tr>
					<th>送信先（B）</th>
					<td>
						<input type="text" name="alert_mail_to2" id="alert_mail_to2" placeholder="例：info@example.com,info2@example.com" style="width:300px;" />
						<p class="indent">※全角文字を自動的に半角文字に変換します</p>
<?php if(array_key_exists('alert_mail_to2', $error)):?>
						<div class="ui-state-error ui-corner-all">
							<p><span class="ui-icon ui-icon-alert"></span><?php echo $error['alert_mail_to2'];?></p>
						</div>
<?php endif; ?>
						<br />
						通知メールの件名<br />
						<input type="text" name="alert_mail_to2_subject" id="alert_mail_to2_subject" placeholder="例：フォームよりお問い合わせがありました。" style="width:150px" />
						<br />
						通知メールの内容<br />
						<textarea name="alert_mail_to2_body" id="alert_mail_to2_body" placeholder="例：問い合わせ内容を確認して下さい。" style="width:300px;height:5em;"></textarea>
<?php if(array_key_exists('alert_mail_to2_body', $error)):?>
						<div class="ui-state-error ui-corner-all">
							<p><span class="ui-icon ui-icon-alert"></span><?php echo $error['alert_mail_to2_body'];?></p>
						</div>
<?php endif; ?>
					</td>
					<td class="un_nowrap">
						フォームの利用があった際に通知内容を指定したメールアドレスに送信します。メールアドレスはカンマ（,）で区切ると宛先を複数指定できます。ただし、複数指定した場合は宛先に指定した全てのアドレスが記載されます。<br />
						携帯電話等に<b>フォームの利用があった旨のみを伝える場合</b>に利用すると便利です。
					</td>
				</tr>
				<tr class="bg">
					<th colspan="2">メールテンプレート</th>
					<td>ヘルプ</td>
				</tr>
				<tr>
					<th>確認メール用<span class="required">【必須】</span><br/>（入力者宛て）</th>
					<td>
						<p>PC用</p>
<?php if(array_key_exists('thanks_mail_template_p', $error)):?>
						<div class="ui-state-error ui-corner-all">
							<p><span class="ui-icon ui-icon-alert"></span><?php echo $error['thanks_mail_template_p'];?></p>
						</div>
<?php endif; ?>
						<textarea name="thanks_mail_template_p" id="thanks_mail_template_p" class="monofont mailtpl_p"></textarea>
						<p>携帯用</p>
<?php if(array_key_exists('thanks_mail_template_k', $error)):?>
						<div class="ui-state-error ui-corner-all">
							<p><span class="ui-icon ui-icon-alert"></span><?php echo $error['thanks_mail_template_k'];?></p>
						</div>
<?php endif; ?>
						<textarea name="thanks_mail_template_k" id="thanks_mail_template_k" class="monofont mailtpl_k"></textarea>
						<p>スマートフォン用</p>
<?php if(array_key_exists('thanks_mail_template_s', $error)):?>
						<div class="ui-state-error ui-corner-all">
							<p><span class="ui-icon ui-icon-alert"></span><?php echo $error['thanks_mail_template_s'];?></p>
						</div>
<?php endif; ?>
						<textarea name="thanks_mail_template_s" id="thanks_mail_template_s" class="monofont mailtpl_s"></textarea>
					</td>
					<td class="un_nowrap">
						確認メール用のテンプレートが設定できます。PC用は<span class="required">入力必須</span>となり、携帯用・スマートフォン用が未設定の場合はPC用を使用します。<br />
						<br />
						使用できる専用タグ<br />
						<table>
							<colgroup width="100"></colgroup>
							<colgroup width="*"></colgroup>
							<tbody>
								<tr>
									<th>{mailform}</th>
									<td>ユーザーの入力情報全て</td>
								</tr>
								<tr>
									<th>{date}</th>
									<td>送信日時（Y年m月d日 H時i分）</td>
								</tr>
								<tr>
									<th>{number}</th>
									<td>送信番号</td>
								</tr>
								<tr>
									<th>{ip}</th>
									<td>利用者のIPアドレス</td>
								</tr>
								<tr>
									<th>{user_agent}</th>
									<td>利用者のブラウザ情報</td>
								</tr>
							</tbody>
						</table>
					</td>
				</tr>
				<tr>
					<th>通知メール用<span class="required">【必須】</span><br/>（管理者宛て）</th>
					<td>
<?php if(array_key_exists('alert_mail_template_p', $error)):?>
						<div class="ui-state-error ui-corner-all">
							<p><span class="ui-icon ui-icon-alert"></span><?php echo $error['alert_mail_template_p'];?></p>
						</div>
<?php endif; ?>
						<textarea name="alert_mail_template_p" id="alert_mail_template_p" class="monofont mailtpl_p"></textarea>
					</td>
					<td class="un_nowrap">
						通知メール用のテンプレートが設定できます。こちらは<span class="required">入力必須</span>です。<br />
						以下専用タグ内の<b>{mailform}</b>が無いとフォーム利用者の入力内容が受け取れませんのでご注意下さい。<br />
						<br />
						使用できる専用タグ<br />
						<table>
							<colgroup width="100"></colgroup>
							<colgroup width="*"></colgroup>
							<tbody>
								<tr>
									<th>{mailform}</th>
									<td>ユーザーの入力情報全て</td>
								</tr>
								<tr>
									<th>{date}</th>
									<td>送信日時（Y年m月d日 H時i分）</td>
								</tr>
								<tr>
									<th>{number}</th>
									<td>送信番号</td>
								</tr>
								<tr>
									<th>{ip}</th>
									<td>利用者のIPアドレス</td>
								</tr>
								<tr>
									<th>{user_agent}</th>
									<td>利用者のブラウザ情報</td>
								</tr>
							</tbody>
						</table>
					</td>
				</tr>
			</tbody>
		</table>
	</form>
	<?php endif;?>
</div>

<div id="modal" title="">
<?php if(isFormConfig):?>
	<div id="select_values_block" class="blocks" rel="textarea">
		<textarea name=""></textarea>
		<p class="indent">※改行で区切って入力して下さい</p>
	</div>
	<div id="output_options_block" class="blocks" rel="checkbox">
		<!-- 入力欄系のみ -->
		<div class="
			 setname-name1
			 setname-name2
			 setname-name1_kata
			 setname-name2_kata
			 setname-name1_hira
			 setname-name2_hira
			 setname-mail1
			 setname-mail2
			 setname-tel1
			 setname-tel2
			 setname-address1
			 setname-address2
			 type-input_text
			 type-textarea">
			<p>※処理は上にあるものから順に行われます。</p>
			<!-- エスケープは削除 -->
			<div><input type="checkbox" value="br" id="output_options_br" /><label for="output_options_br">自動改行</label></div>
			<div><input type="checkbox" value="comma" id="output_options_comma" /><label for="output_options_comma">3桁おきにカンマ</label>（入力値が数値の場合に限ります）　例：10000 → 10,000</div>
			<div><input type="checkbox" value="dec" id="output_options_dec" rel="ignore"/><label for="output_options_dec">整数値の桁整形</label>（<select name="output_options_dec_value" id="output_options_dec_value"><?php for($i=1;$i<=10;$i++):?><option value="<?php echo $i;?>"><?php echo $i;?></option><?php endfor;?></select>）　例：入力値が「1」で5桁の場合　→　00001</div>
			<div><input type="checkbox" value="urlencode" id="output_options_urlencode" /><label for="output_options_urlencode">URLエンコード</label></div>
		</div>
		<div style="margin-top:.5em;">
			<button class="clear">全てのチェックを外す</button>
		</div>
	</div>
	<div id="convert_options_block" class="blocks" rel="checkbox">
		<!-- 入力欄系のみ、セット系は勝手にチェックするので不要 -->
		<div class="type-input_text type-textarea">
			<p>※処理は上にあるものから順に行われます。</p>
			<div><input type="checkbox" value="trim"  id="convert_options_trim"  /><label for="convert_options_trim" >前後の空白文字を除去（全角空白、半角空白、タブ等）</label></div>
			<div><input type="checkbox" value="sani"  id="convert_options_sani"  /><label for="convert_options_sani" >HTMLタグを削除</label></div>
			<div><input type="checkbox" value="hn2zn" id="convert_options_hn2zn" /><label for="convert_options_hn2zn">数値を全角に（例：123 → １２３）</label></div>
			<div><input type="checkbox" value="zn2hn" id="convert_options_zn2hn" /><label for="convert_options_zn2hn">数値を半角に（例：１２３ → 123）</label></div>
			<div><input type="checkbox" value="hl2zl" id="convert_options_hl2zl" /><label for="convert_options_hl2zl">英字を全角に（例：ABC → ＡＢＣ）</label></div>
			<div><input type="checkbox" value="zl2hl" id="convert_options_zl2hl" /><label for="convert_options_zl2hl">英字を半角に（例：ＡＢＣ → ABC）</label></div>
			<div><input type="checkbox" value="ha2za" id="convert_options_ha2za" /><label for="convert_options_ha2za">英字＋記号を全角に（例：ABC/*-+ → ＡＢＣ／＊−＋）</label></div>
			<div><input type="checkbox" value="za2ha" id="convert_options_za2ha" /><label for="convert_options_za2ha">英字＋記号を半角に（例：ＡＢＣ／＊−＋ → ABC/*-+）</label></div>
			<div><input type="checkbox" value="zk2hk" id="convert_options_zk2hk" /><label for="convert_options_zk2hk">カタカナを全角に（例：ｱｲｳ → アイウ）</label></div>
			<div><input type="checkbox" value="hk2zh" id="convert_options_hk2zh" /><label for="convert_options_hk2zh">カタカナをひらがなに（例：ｱｲｳ → あいう）</label></div>
			<div><input type="checkbox" value="hk2zk" id="convert_options_hk2zk" /><label for="convert_options_hk2zk">カタカナを半角に（例：アイウ → ｱｲｳ）</label></div>
			<div><input type="checkbox" value="zk2zh" id="convert_options_zk2zh" /><label for="convert_options_zk2zh">カタカナをひらがなに（例：アイウ → あいう）</label></div>
			<div><input type="checkbox" value="zh2zk" id="convert_options_zh2zk" /><label for="convert_options_zh2zk">ひらがなを全角カタカナに（例：あいう → アイウ）</label></div>
			<div><input type="checkbox" value="zh2hk" id="convert_options_zh2hk" /><label for="convert_options_zh2hk">ひらがなを半角カタカナに（例：あいう → ｱｲｳ）</label></div>
		</div>
		<div style="margin-top:.5em;">
			<button class="clear">全てのチェックを外す</button>
		</div>
	</div>
	<div id="check_options_block" class="blocks" rel="checkbox">
		<!-- 入力欄系のみ、セット系は勝手にチェックするので不要 -->
		<div class="
			 type-input_text
			 type-textarea
			 ">
			<div>
				<input type="checkbox" value="hankaku" rel="ignore" id="check_options_hankaku" /><label for="check_options_hankaku">半角</label>
				<ul>
					<li><input type="checkbox" value="alpha_h_upper" id="check_options_alpha_h_upper" /><label for="check_options_alpha_h_upper">半角英字(大)</label></li>
					<li><input type="checkbox" value="alpha_h_lower" id="check_options_alpha_h_lower" /><label for="check_options_alpha_h_lower">半角英字(小)</label></li>
					<li><input type="checkbox" value="h_number" id="check_options_h_number" /><label for="check_options_h_number">半角数字</label></li>
					<li><input type="checkbox" value="hankana" id="check_options_hankana" /><label for="check_options_hankana">ｶﾀｶﾅ</label></li>
				</ul>
			</div>
			<div>
				<input type="checkbox" value="zenkaku" rel="ignore" id="check_options_zenkaku" /><label for="check_options_zenkaku">全角</label>
				<ul>
					<li><input type="checkbox" value="alpha_z_upper" id="check_options_alpha_z_upper" /><label for="check_options_alpha_z_upper">全角英字(大)</label></li>
					<li><input type="checkbox" value="alpha_z_lower" id="check_options_alpha_z_lower" /><label for="check_options_alpha_z_lower">全角英字(小)</label></li>
					<li><input type="checkbox" value="z_number" id="check_options_z_number" /><label for="check_options_z_number">全角数字</label></li>
					<li><input type="checkbox" value="hiragana" id="check_options_hiragana" /><label for="check_options_hiragana">ひらがな</label></li>
					<li><input type="checkbox" value="zenkana" id="check_options_zenkana" /><label for="check_options_zenkana">カタカナ</label></li>
				</ul>
			</div>
			<div>
				<input type="checkbox" value="other" rel="ignore" id="check_options_other" /><label for="check_options_other">その他</label>
				<ul>
					<li><input type="checkbox" value="other_n" id="check_options_other_n" /><label for="check_options_other_n">キャリッジリターン[CR](\r)</label></li>
					<li><input type="checkbox" value="other_r" id="check_options_other_r" /><label for="check_options_other_r">ラインフィード[LF](\n)</label></li>
					<li><input type="checkbox" value="other_t" id="check_options_other_t" /><label for="check_options_other_t">タブ(\t)</label></li>
					<li><input type="checkbox" value="other_s" id="check_options_other_s" /><label for="check_options_other_s">スペース(\s)</label></li>
				</ul>
			</div>
			<div>
				<input type="checkbox" value="sign" id="check_options_sign" /><label for="check_options_sign">指定記号</label>
				<ul>
					<li><input type="text" name="other_sign" id="check_options_other_sign" value="" /></li>
				</ul>
			</div>
		</div>
		<!-- ファイルアップロード系のみ -->
		<div class="setname-file1 setname-file2">
			<div>
				<input type="checkbox" value="image" rel="ignore" id="check_options_image" /><label for="check_options_image">画像</label>
				<ul>
					<li><input type="checkbox" value="jpg" id="check_options_jpg" /><label for="check_options_jpg">jpg(jpeg,jpe)</label></li>
					<li><input type="checkbox" value="gif" id="check_options_gif" /><label for="check_options_gif">gif</label></li>
					<li><input type="checkbox" value="png" id="check_options_png" /><label for="check_options_png">png</label></li>
					<li><input type="checkbox" value="tiff" id="check_options_tiff" /><label for="check_options_tiff">tiff</label></li>
					<li><input type="checkbox" value="bmp" id="check_options_bmp" /><label for="check_options_bmp">bmp</label></li>
				</ul>
			</div>
			<div>
				<input type="checkbox" value="document" rel="ignore" id="check_options_document" /><label for="check_options_document">ドキュメント</label>
				<ul>
					<li><input type="checkbox" value="doc" id="check_options_doc" /><label for="check_options_doc">Word(doc,docx)</label></li>
					<li><input type="checkbox" value="xls" id="check_options_xls" /><label for="check_options_xls">Excel(xls,xlsx)</label></li>
					<li><input type="checkbox" value="ptt" id="check_options_ptt" /><label for="check_options_ptt">Powerpoint(ptt,pttx)</label></li>
					<li><input type="checkbox" value="pdf" id="check_options_pdf" /><label for="check_options_pdf">PDF</label></li>
					<li><input type="checkbox" value="txt" id="check_options_txt" /><label for="check_options_txt">テキスト</label></li>
				</ul>
			</div>
			<div>
				<input type="checkbox" value="archive" rel="ignore" id="check_options_archive" /><label for="check_options_archive">アーカイブ</label>
				<ul>
					<li><input type="checkbox" value="zip" id="check_options_zip" /><label for="check_options_zip">ZIP</label></li>
					<li><input type="checkbox" value="lzh" id="check_options_lzh" /><label for="check_options_lzh">LZH</label></li>
					<li><input type="checkbox" value="rar" id="check_options_rar" /><label for="check_options_rar">RAR</label></li>
					<li><input type="checkbox" value="gz" id="check_options_gz" /><label for="check_options_gz">GZ</label></li>
				</ul>
			</div>
			<div>
				<input type="checkbox" value="other_extension" rel="ignore" id="check_options_other_extension" /><label for="check_options_other_extension">上記以外の拡張子</label>
				<ul>
					<li><input type="text" name="other_extensions" id="check_options_other_extensions" />（拡張子をカンマ(,)区切りで入力）</li>
				</ul>
			</div>
			<div>
				<input type="checkbox" value="filesize" rel="ignore" id="check_options_filesize" /><label for="check_options_filesize">アップロード可能な容量制限</label>
				<ul>
					<li>
						<select name="check_options_size" id="check_options_filesize_size">
							<option value="1">1</option>
							<option value="2">2</option>
							<option value="3">3</option>
							<option value="4">4</option>
							<option value="5">5</option>
							<option value="6">6</option>
							<option value="7">7</option>
							<option value="8">8</option>
							<option value="9">9</option>
							<option value="10">10</option>
							<option value="20">20</option>
							<option value="30">30</option>
							<option value="40">40</option>
							<option value="50">50</option>
							<option value="100">100</option>
						</select>
						<select name="check_options_byte" id="check_options_filesize_byte">
							<option value="KB">KB</option>
							<option value="MB">MB</option>
						</select>
						<p class="indent">※現在お使いのサーバーのPHP.iniでは POST可能なサイズは <span class="red"><?php echo ini_get('post_max_size');?></span>(post_max_size)、またアップロードできるサイズは <span class="red"><?php echo ini_get('upload_max_filesize');?></span>(upload_max_filesize)までと設定されています。この値より大きな値を設定したい場合は.htaccess等で設定を変更する必要があります。</p>
						<p class="indent">例）<span class="red">50M</span>に設定する場合の.htaccessの中身<br />
							# POST可能なサイズ（フォーム全体の容量なので少し多めに）<br />
							php_value post_max_size <span class="red">"60M"</span><br />
							# アップロード可能なサイズ（フォーム全体なので複数設置されている場合は等分）<br />
							php_value upload_max_filesize <span class="red">"50M"</span><br />
						</p>
					</li>
				</ul>
			</div>
		</div>
		<div style="margin-top:.5em;">
			<button class="clear">全てのチェックを外す</button>
		</div>
	</div>
<?php endif;?>
</div>

<div id="passwd" style="overflow:hidden;display:none;">
	<iframe name="iframe" id="iframe" style="display:none"></iframe>
	<form action="<?php echo $action;?>" method="post" target="iframe" style="text-align: center;">
		<input type="text" name="new_password" class="nosavecheck" value="" placeholder="新しいパスワードを入力" style="width:160;" />
	</form>
</div>

</body>
</html>